
CREATE TABLE 'wsbase' (
  'pageTitle'   TEXT      NULL,
  'prevWeb'     INTEGER   NOT NULL default '1',
  'prevAct'     INTEGER   NOT NULL default '1',
  'prevPDF'     INTEGER   NOT NULL default '1',
  'activeLog'   INTEGER   NOT NULL default '1',
  'vClock'      INTEGER   NOT NULL default '1',
  'effectAct'   INTEGER   NOT NULL default '1',
  'sepAdr'      INTEGER   NOT NULL default '1',
  'compPath'    INTEGER   NOT NULL default '1',
  'arboLink'    INTEGER   NOT NULL default '1',
  'autoUserAcc' INTEGER   NOT NULL default '1',
  'dynWin'      INTEGER   NOT NULL default '1',
  'linkWin'     INTEGER   NOT NULL default '1',
  'sendMail'    INTEGER   NOT NULL default '1',
  'actConf'     INTEGER   NOT NULL default '1',
  'clicl'       INTEGER   NOT NULL default '1',
  'clicr'       INTEGER   NOT NULL default '1',
  'clicd'       INTEGER   NOT NULL default '1',
  'memoMax'     TEXT      default NULL,
  'execMax'     TEXT      default NULL,
  'postMax'     TEXT      default NULL,
  'timeMax'     TEXT      default NULL,
  'uploMax'     TEXT      default NULL,
  'lifeMax'     TEXT      default NULL,
  'diapoSp'     INTEGER   NULL
);

INSERT INTO 'wsbase' (
  'pageTitle', 'prevWeb', 'prevAct', 'prevPDF', 'activeLog',
  'vClock', 'effectAct', 'sepAdr', 'compPath', 'arboLink', 'dynWin',
  'linkWin', 'sendMail', 'actConf', 'clicl', 'clicr', 'clicd', 'memoMax',
  'execMax', 'postMax', 'timeMax', 'uploMax', 'lifeMax', 'diapoSp')
  VALUES ('Webshare', 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1,
    NULL, NULL, NULL, NULL, NULL, NULL, 5000);

CREATE TABLE 'wslog' (
  'idope'       INTEGER   PRIMARY KEY,
  'idaction'    INTEGER   NOT NULL default '1',
  'idresult'    INTEGER   NOT NULL default '1',
  'iddate'      DATETIME  NOT NULL default '0000-00-00 00:00:00',
  'username'    TEXT      NOT NULL,
  'path'        TEXT      NOT NULL default '',
  'file'        TEXT      NOT NULL default '',
  'ipadr'       TEXT      NOT NULL,
  'verbose'     TEXT      NULL,
  'content'     TEXT      NULL
);

CREATE TABLE 'wsuser' (
  'idUser'      INTEGER   NOT NULL,
  'typeUser'    INTEGER   NOT NULL default '1',
  'nomUser'     TEXT      default NULL,
  'mailUser'    TEXT      default NULL,
  'logUser'     TEXT      default NULL,
  'passUser'    TEXT      default NULL,
  'serveurs'    TEXT      default NULL,
  'langUser'    TEXT      default NULL,
  'styleUser'   TEXT      default NULL,
  'visuUser'    TEXT      default NULL,
  'triUser'     TEXT      default NULL,
  'varsUser'    TEXT      NOT NULL,
  'webUser'     INTEGER   NOT NULL default '1',
  'arboUser'    INTEGER   NOT NULL default '1',
  'publicUser'  TEXT      NULL,
  'auth1'       TEXT      NULL default 'on',
  'auth2'       TEXT      NULL default 'on',
  'auth3'       TEXT      NULL default 'on',
  'auth4'       TEXT      NULL default 'on',
  'auth5'       TEXT      NULL default 'on',
  'auth6'       TEXT      NULL default 'on',
  'auth7'       TEXT      NULL default 'on',
  'auth8'       TEXT      NULL default 'on'
);

INSERT INTO 'wsuser' (
  'idUser', 'typeUser', 'nomUser', 'logUser', 'passUser',
  'serveurs', 'langUser', 'styleUser', 'visuUser', 'triUser', 'varsUser',
  'webUser', 'arboUser', 'auth1', 'auth2', 'auth3', 'auth4', 'auth5', 'auth6',
  'auth7', 'auth8')
  VALUES (0, 1, 'webAdmin', 'root', '63a9f0ea7bb98050796b649e85481845', 'Documents',
    'Auto', 'Standard', 'miniatures', 'extension',
    'admin|wspasswd|moteur|wsminis|wssite|htaccess|htpass|cgi|php|htm|sessions|Thumbs|asp$|aspx$|ini$|pl$|cgi$|js$|jsp$|dhtml$|cfm$|old$|~|^[.]{1}|^[.]{2}',
    0, 1, 'on', 'on', 'on', 'on', 'on', 'on', 'on', 'on');

CREATE TABLE 'wsserver' (
  'idServeur'      INTEGER   NOT NULL,
  'typeServeur'    INTEGER   NOT NULL default '1',
  'triServeur'     TEXT      NOT NULL default '0',
  'nomServeur'     TEXT      NOT NULL,
  'rootServeur'    TEXT      NOT NULL default '/',
  'repServeur'     TEXT      NOT NULL default '',
  'startServeur'   TEXT      NOT NULL default '',
  'adrServeur'     TEXT      NULL,
  'logServeur'     TEXT      NULL,
  'passServeur'    TEXT      NULL,
  'portServeur'    TEXT      NULL,
  'webServeur'     TEXT      NULL,
  'protectIndex'   TEXT      NOT NULL default '0',
  'protectHtacc'   TEXT      NOT NULL default '0',
  'binServeur'     TEXT      NOT NULL default '1',
  'protectServeur' TEXT      NOT NULL default '0',
  'publicServeur'  TEXT      NOT NULL default '0'
);

INSERT INTO 'wsserver' (
  'idServeur', 'typeServeur', 'triServeur', 'nomServeur',
  'rootServeur', 'repServeur', 'startServeur', 'adrServeur', 'logServeur',
  'passServeur', 'portServeur', 'webServeur', 'protectIndex', 'protectHtacc', 'binServeur',
  'protectServeur')
  VALUES (0, 1, '0', 'Documents', '$mydoc$', '', '', '', '', '', '', '', '0', '0', '1', '0');

CREATE TABLE 'wsfiles' (
  'idfiles'        INTEGER   PRIMARY KEY,
  'idUser'         INTEGER   NOT NULL,
  'idServeur'      INTEGER   NOT NULL,
  'username'       TEXT      NOT NULL,
  'nomServeur'     TEXT      NOT NULL,
  'path'           TEXT      NOT NULL,
  'file'           TEXT      NOT NULL,
  'commentaires'   TEXT      NULL,
  'version'        TEXT      NULL,
  'viewed'         INTEGER   NULL,
  'favoris'        INTEGER   NOT NULL default '0',
  'changed'        INTEGER   NULL,
  'locked'         INTEGER   NULL
);

CREATE TABLE 'wsasso' (
  'idasso'         INTEGER   PRIMARY KEY,
  'type'           TEXT      default NULL,
  'libelle'        TEXT      default NULL,
  'mime'           TEXT      default NULL,
  'action1'        TEXT      default NULL,
  'action2'        TEXT      default NULL
);

INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES ( 1, 'jpeg', 'Image Jpeg', 'image/jpeg', '6', '5');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES ( 2, 'jpg', 'Image Jpeg', 'image/jpeg', '6', '5');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES ( 3, 'png', 'Image Png', 'image/png', '6', '5');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES ( 4, 'gif', 'Image Gif', 'image/gif', '6', '5');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES ( 5, 'tif', 'Image Tiff', 'image/tiff', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES ( 6, 'bmp', 'Image Bitmap', 'image/bmp', '6', '5');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES ( 7, 'psd', 'Image Photoshop', 'x-vnd.adobe.photoshop', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES ( 8, 'ai', 'Document Illustrator', 'application/postscript', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES ( 9, 'indd', 'Document Indesign', 'application/postscript', '2', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (10, 'eps', 'Fichier PostScript', 'application/postscript', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (11, 'ps', 'Fichier PostScript', 'application/postscript', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (12, 'ttf', 'Fonte TrueType', 'application/x-font-TrueType', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (13, 'otf', 'Fonte OpenType', 'application/x-font-TrueType', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (14, 'pdf', 'Document portable', 'application/pdf', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (15, 'doc', 'Document Word', 'application/msword', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (16, 'xls', 'Classeur Excel', 'application/vnd.ms-excel', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (17, 'ppt', 'Presentation Powerpoint', 'application/vnd.ms-powerpoint', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (18, 'odt', 'Traitement de texte', 'application/vnd.oasis.opendocument.text', '2', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (19, 'ods', 'Tableur', 'application/vnd.oasis.opendocument.spreadsheet', '2', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (20, 'odp', 'Presentation', 'application/vnd.oasis.opendocument.presentation', '2', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (21, 'odg', 'Dessin', 'application/vnd.oasis.opendocument.graphics', '2', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (22, 'odf', 'Formule', 'application/vnd.oasis.opendocument.formula', '2', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (23, 'odb', 'Base de donnees', 'application/vnd.oasis.opendocument.database', '2', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (24, 'htm', 'Page web', 'text/html', '5', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (25, 'html', 'Page web', 'text/html', '5', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (26, 'xml', 'Document Xml', 'text/xml', '5', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (27, 'rss', 'Flux RSS', 'text/xml', '5', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (28, 'url', 'Lien Internet', 'text/plain', '5', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (29, 'rtf', 'Texte enrichi', 'application/rtf', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (30, 'txt', 'Document texte', 'text/plain', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (31, 'ini', 'Fichier de configuration', 'text/plain', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (32, 'c', 'Script C', 'text/plain', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (33, 'cpp', 'Script Cpp', 'text/plain', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (34, 'php', 'Script PHP', 'text/plain', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (35, 'asp', 'Script ASP', 'text/plain', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (36, 'aspx', 'Script ASP.NET', 'text/plain', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (37, 'js', 'Script Javascript', 'application/javascript', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (38, 'css', 'Fichier de style', 'text/css', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (39, 'sql', 'Base MySQL', 'text/plain', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (40, 'log', 'Fichier de log', 'text/plain', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (41, 'mp3', 'Audio MP3', 'audio/mp3', 'mp3player', '8');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (42, 'ogg', 'Audio Ogg', 'application/ogg', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (43, 'wav', 'Fichier audio', 'audio/x-wav', 'wmplayer', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (44, 'mid', 'Fichier midi', 'audio/x-midi', 'wmplayer', 'qtplayer');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (45, 'm3u', 'Playlist audio', 'text/plain', '1', 'editor');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (46, 'ra', 'RealMedia', 'audio/vnd.rn-realaudio', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (47, 'mov', 'Video Quicktime', 'video/mov', 'qtplayer', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (48, 'qt', 'Video Quicktime', 'video/quicktime', 'qtplayer', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (49, 'mpg', 'Video Mpeg', 'video/mpeg', 'wmplayer', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (50, 'mpeg', 'Video Mpeg', 'video/mpeg', 'wmplayer', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (51, 'wma', 'Windows Media Audio', 'audio/x-ms-wma', 'wmplayer', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (52, 'wmv', 'Windows Media Video', 'video/msvideo', 'wmplayer', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (53, 'avi', 'Video Avi', 'video/msvideo', 'qtplayer', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (54, 'divx', 'Video Divx', 'video/divx', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (55, 'flv', 'Video Flash', 'video/flash', 'flashplayer', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (56, 'fla', 'Document Flash', 'application/x-flash', 'flashplayer', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (57, 'swf', 'Animation Flash', 'application/x-shockwave-flash', 'flashplayer', '5');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (58, 'zip', 'Archive Zip', 'application/zip', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (59, 'rar', 'Archive Rar', 'application/zip', '3', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (60, 'tar', 'Archive Tar', 'application/x-tar', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (61, 'gz', 'Archive Tar', 'application/x-tar', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (62, 'iso', 'Image disque', 'application/octet-stream', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (63, 'java', 'Script Java', 'application/octet-stream', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (64, 'dll', 'Librairie dynamique', 'application/octet-stream', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (65, 'exe', 'Executable Windows', 'application/octet-stream', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (66, 'tmp', 'Fichier temporaire', 'application/octet-stream', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (67, 'docx', 'Document Word', 'application/msword', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (68, 'xlsx', 'Classeur Excel', 'application/vnd.ms-excel', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (69, 'pptx', 'Presentation Powerpoint', 'application/vnd.ms-powerpoint', '5', '2');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (70, 'icc', 'Profil colorimétrique', 'application/octet-stream', '2', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (71, 'mp4', 'Video Mp4', 'vido/mp4', 'qtplayer', '5');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (72, 'tgz', 'Archive Tar', 'application/x-gzip', '3', '3');
INSERT INTO 'wsasso' ('idasso', 'type', 'libelle', 'mime', 'action1', 'action2')
  VALUES (73, 'ico', 'Image Icon', 'image/x-icon', '6', '2');
