<?php
/************************************************************************/
/*                                WEBSHARE                              */
/************************************************************************/
//
// Copyright (c) 2009 by Virginie Vivancos
// http://www.webshare.fr
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License.
//
// =======================================================================
// Fonction : Modifie les droits sur un dossier ou un fichier
// Nom      : autoriser.php
// Version  : 0.8.2
// Date     : 24/04/09
// =======================================================================
// WebShare0.8.2ακ1.7 : 2012 Tanabata version.
// Reformed by kiyoshi@kuragane.jp / 2012.02.09(κ1.0) - 2012.07.07(κ1.7)
// =======================================================================

//// アクセス権の表示や変更をする。

session_start();
include_once "auth.php";
include_once "../wspasswd/define.php";
include_once "fonctions.php";

// L'utilisateur ne peut pas effectuer d'opération au dessus de sa racine virtuelle
verifie($_REQUEST["nomElement"]);

$l_sql = new class_sql();
$l_sql->connect();

// Récupération des informations serveurs
if(!empty($_REQUEST["nomSrv"])){ $nomSrv = $_REQUEST["nomSrv"]; }
else{ $nomSrv = $_SESSION["ws"]["serveurActif"]; }
$nomPro  = $_REQUEST["nomPro"];
$typeSrv = $_SESSION["ws"]["$nomSrv"]["typeServeur"];
$chemin  = blindeChemin($_SESSION["ws"]["$nomSrv"]["rootServeur"]."/".$_SESSION["ws"]["$nomSrv"]["repServeur"]."/");
$message = $_SESSION["ws"]["dia"]["prohibited"];

// L'utilisateur doit être autorisé à effectuer l'opération
if($_SESSION["ws"]["auth6"] == "on")
{
	// Construction des chemins
	$nomLien       = stripslashes(rawurldecode(trim($_REQUEST["nomLien"])));
	$cheminDossier = stripslashes(blindeChemin(convertUTF8($chemin)));
	$cheminElement = stripslashes(blindeChemin(convertUTF8($chemin).$nomLien));
	$nomElement    = stripslashes(rawurldecode(trim($_REQUEST["nomElement"])));

	// Test du contenu des variables
	if(preg_match($_SESSION["ws"]["varsUser"], $nomLien))
	{
		echo $_SESSION["ws"]["dia"]["noPermission"];
		$tabLog = array("10", "-1", $_SESSION["ws"]["dia"]["noPermission"], $_SESSION["ws"]["nomUser"], $cheminElement, $nomElement, "");
		$l_sql->logAction($tabLog);
		$l_sql->disconnect();
		exit;
	}

	// Récupération des droits
	if(!empty($_REQUEST["infoDroit"])) //// アクセス権の表示。
	{
		if($typeSrv == "2"){ $_SESSION["ws"]["$nomSrv"]["connexion"] = connexionFTP($nomSrv); }
		$perms = F_fileperms($nomSrv, $cheminElement);
		if($perms){ echo $perms; }
		if($typeSrv == "2"){ closeFTP($nomSrv); }
		$l_sql->disconnect();
		exit;
	}

	// Modification des droits
	if(!empty($_REQUEST["valeurDroit"])) //// アクセス権の変更。
	{
		$message = $_SESSION["ws"]["dia"]["fileAttributes"]." '".filename($nomLien)."' ";
		if($typeSrv == "2"){ $_SESSION["ws"]["$nomSrv"]["connexion"] = connexionFTP($nomSrv); }
		$valeur = sprintf("%04s", $_REQUEST["valeurDroit"]);
		if(F_chmod($nomSrv, $cheminElement, octdec($valeur)) === false)
		{ $message .= $_SESSION["ws"]["dia"]["cantModify"]; }
		else
		{ $message .= $_SESSION["ws"]["dia"]["modify"]; }
		if($typeSrv == "2"){ closeFTP($nomSrv); }
	}
	else
	{
		$message = $_SESSION["ws"]["dia"]["noPermission"];
	}
}

function F_fileperms($nomSrv, $chemin)
{
	if(F_is_FTPServeur($nomSrv))
	{
		$droitsC = array("rwx", "rw-", "r-x", "r--", "-wx", "-w-", "--x", "---", "d");
		$droitsN = array("7",   "6",   "5",   "4",   "3",   "2",   "1",   "0",   "0");
		$cheminScan = dirname($chemin);
		$filename   = filename($chemin);
		if(($contents = B_ftp_rawlist($nomSrv, blindeChemin($cheminScan))) !== FALSE)
		{
			foreach($contents as $file)
			{
				if(preg_match("@\s$filename$@u", $file))
				{
					$fileperms = substr($file, 0, 10);
					$droits = intval(str_replace($droitsC, $droitsN, $fileperms));
					return octdec($droits);
				}
			}
		}
	}
	else
	{
		return @fileperms($chemin);
	}
	return NULL;
}

function F_chmod($nomSrv, $chemin, $perm=0)
{
	if(F_is_FTPServeur($nomSrv))
	{
		B_ftp_update($nomSrv);
		if(F_is_dir($nomSrv, $chemin))
		{ return @ftp_chmod($_SESSION["ws"]["$nomSrv"]["connexion"], ($perm?$perm:NEWFTPDIR_PERM), $chemin); }
		else
		{ return @ftp_chmod($_SESSION["ws"]["$nomSrv"]["connexion"], ($perm?$perm:NEWFTPFILE_PERM), $chemin); }
	}
	else
	{
		if(is_dir($chemin))
		{ return @chmod($chemin, ($perm?$perm:NEWDIR_PERM)); }
		else
		{ return @chmod($chemin, ($perm?$perm:NEWFILE_PERM)); }
	}
}


echo $message;
$tabLog= array("10", "1", $message, $_SESSION["ws"]["nomUser"], $cheminElement, $nomElement, "");
$l_sql->logAction($tabLog);
$l_sql->disconnect();

?>
