<?php
/************************************************************************/
/*                                WEBSHARE                              */
/************************************************************************/
//
// Copyright (c) 2009 by Virginie Vivancos
// http://www.webshare.fr
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License.
//
// =======================================================================
// Fonction : Définit des fonctions globales
// Nom      : fonctions.php
// Version  : 0.8.2
// Date     : 24/04/09
// =======================================================================
// WebShare0.8.2ακ1.7.1 : 2013 Tanabata version+.
// Reformed by kiyoshi@kuragane.jp / 2012.02.09(κ1.0) - 2013.11.23(κ1.7.2)
// =======================================================================

//// 主にアクセス関係のユーティリティー関数。

//// データ圧縮を行う。ブラウザが受入可能か否かを調べて自動的に行われる。
ob_start('ob_gzhandler'); ////

// Default setting : Setting file is "../wspasswd/define.php"
if(!defined("USE_wssite")){ define("USE_wssite", TRUE); } // Make parameters in program installed site or not.
if(!defined("MINIMAXSIZE")){ define("MINIMAXSIZE", 100); } // Max size of miniature (px).
if(!defined("FTP_PASSIVE")){ define("FTP_PASSIVE", TRUE); } // Use FTP passive connection or not.
if(!defined("FTP_BUFTIME")){ define("FTP_BUFTIME", 5); } // FTP filelist buffering time (sec).
if(!defined("SQL_TYPE")){ define("SQL_TYPE", "MySQL"); } // SQL Server type (If use). "MySQL","SQLite2","SQLite2PDO","SQLite3PDO"or"None".
if(!defined("SQL_LOG_MAX")){ define("SQL_LOG_MAX", 1000); } // Max log lines of SQL.
if(!defined("ESCAPE_FILENAME")){ define("ESCAPE_FILENAME", TRUE); } // Escape multi-byte chars in filename or not.
if(!defined("NEWDIR_PERM")){ define("NEWDIR_PERM",  0775); } // Directory permissin when make directory.
if(!defined("NEWFILE_PERM")){ define("NEWFILE_PERM", 0664); } // File permission when make file.
if(!defined("NEWFTPDIR_PERM")){ define("NEWFTPDIR_PERM",  0775); } // FTP directory permissin when make directory.
if(!defined("NEWFTPFILE_PERM")){ define("NEWFTPFILE_PERM", 0664); } // FTP file permission when make file.
if(!defined("EXPLORER_CORBEILLE")){ define("EXPLORER_CORBEILLE", 2); } // User level of display corbaille in explorer window.
if(!defined("LOCKED_ICON")){ define("LOCKED_ICON", 2); } // User level of display locked icon.
if(!defined("UNLOCKED_ICON")){ define("UNLOCKED_ICON", 2); } // User level of display unlocked icon.
if(!defined("MENU_IMAGEMODIFY")){ define("MENU_IMAGEMODIFY", 2); } // User level to show image modify context menu.
if(!defined("CONTEXT_BUTTON")){ define("CONTEXT_BUTTON", FALSE); } // Display context menu button or not.
if(!defined("SHOW_DISKINFO")){ define("SHOW_DISKINFO", TRUE); } // Display disk info(free space, etc.) or not.
if(!defined("PREVIEW_IMGQUALITY")){ define("PREVIEW_IMGQUALITY", 50); } // Preview image comressing quality factor(30:Low Quality-100:High). 0 is no compress.
if(!defined("ADDFAV_WINDOW")){ define("ADDFAV_WINDOW", TRUE); } // Display Add to Favoris Window or not.

if(preg_match("@MSIE [5-7]@i",    $_SERVER["HTTP_USER_AGENT"])){ $navig="IE7"; }
elseif(preg_match("@MSIE |Trident/@i",     $_SERVER["HTTP_USER_AGENT"])){ $navig="IE";  }
elseif(preg_match("@KHTML@i",     $_SERVER["HTTP_USER_AGENT"])){ $navig="KH";  }
elseif(preg_match("@opera@i",     $_SERVER["HTTP_USER_AGENT"])){ $navig="OP";  }
elseif(preg_match("@^Mozilla/@i", $_SERVER["HTTP_USER_AGENT"])){ $navig="MO";  }
else{                                                            $navig="NS";  }
if($navig=="IE7"){ $instr = "client"; }
else{ $instr = "offset"; }
if($navig=="IE"||$navig=="IE7"){ $filtre = 'filter:alpha(opacity=0)'; }
else{ $filtre = 'opacity:0'; }

$libraryImg = "gd";
//////if(extension_loaded("imagick")){ $libraryImg = "im"; }////うまくいかない。
exec("convert -version", $out);
if(preg_match("@ImageMagick@", $out[1]) == 1) { $libraryImg = "ic"; }
//////echo('<script>alert("libraryImg='.$libraryImg.'");</script>');
//// アイコンを作成できる画像タイプ。画像プレビューの次へ、前へボタン、スライドショーで表示する際の選択にも使われる。
if($libraryImg == "gd" || $libraryImg == "im") { $typeImgReco = "/jpe?g|png|gif/i"; }
//else { $typeImgReco = "/png|jpeg|jpg|bmp|gif|cur|dcr|dib|emf|eps|ico|pdf|ps|psd|svg|tga|tif|ai/i"; } //// 変えた。デリミタ"/"は変えてはいけない。他で操作している。
elseif(mb_eregi('\bheteml\b', $_SERVER['SERVER_ADMIN'])){ $typeImgReco = "/jpe?g|png|gif|bmp|ico|tif/i"; }////hetemlでpdfうまくいかない。
else { $typeImgReco = "/jpe?g|png|gif|bmp|ico|pdf|tif/i"; }

// Fonctions de corrections de mise en forme des noms et liens
function blindeNom($v_in)
{
	$v_out = str_replace("&", "&amp;", $v_in);
	$v_out = convertUTF8($v_out);
	return $v_out;
}

function blindeLien($v_in)
{
	$v_in = convertUTF8(htmlspecialchars($v_in));
	$v_out = preg_replace("@(?:%2F)+|//+|(?:^|/+)\./+|\\\\+@u", "/", $v_in);
	return $v_out;
}


function blindeChemin($v_in)
{
	$v_out = preg_replace("@(?:%2F)+|//+|(?:^|/+)\./+|\\\\+@u", "/", $v_in);
	return $v_out;
}


function blindeAffichage($v_in)
{
	$v_out = convertUTF8($v_in);
	return $v_out;
}


// Retourne la racine serveur quelquesoit la configuration
function getDocumentRoot()
{
	if(empty($_SERVER["DOCUMENT_ROOT"]))
	{
		$pathRoot = blindeChemin(isset($_SERVER["PATH_TRANSLATED"]) ? $_SERVER["PATH_TRANSLATED"] : realpath($_SERVER["SCRIPT_FILENAME"]));
		$pathFile = blindeChemin(isset($_SERVER["SCRIPT_NAME"]) ? $_SERVER["SCRIPT_NAME"] : $_SERVER["PHP_SELF"]);
		if(empty($pathFile)) { $pathFile = blindeChemin($_SERVER["ORIG_PATH_INFO"]); }
		$docRoot = str_replace($pathFile, "", $pathRoot)."/";
	}
	else
	{
		$docRoot= $_SERVER["DOCUMENT_ROOT"]; 
	}
	return $docRoot;
}


// Retourne la racine script quelquesoit la configuration
function getScriptRoot()
{
	$pathRoot = dirname(blindeChemin(isset($_SERVER["PATH_TRANSLATED"]) ? $_SERVER["PATH_TRANSLATED"] : realpath($_SERVER["SCRIPT_FILENAME"])));
	return $pathRoot;
}

// basename() has BUG!. Not work if basename contains Japanese chars.
// rawurlencodeされていないUTF-8生のパスだとbasename()は日本語部分が空になる。 dirnameはOK。
function filename($path)
{
	$path = preg_replace('@/+$@u', '', $path);
	return  preg_replace('@^.*/([^/]+)@u', '\1', $path);
}

//// パス、ファイル名、フォルダ名、urlなどの名前が妥当かチェックする。
// Vérifie que le chemin ne contient [pas de lien vers le niveau supérieur
function verifie($nomChemin)
{
	if(!isset($nomChemin) || empty($nomChemin) || (mb_strpos(html_entity_decode($nomChemin), "..") !== FALSE)
		|| preg_match($_SESSION["ws"]["varsUser"], html_entity_decode($nomChemin)))
	{
		echo $_SESSION["ws"]["dia"]["noOperation"];
		exit;
	}
}


//// パーミッション"RW", "R", "W", "N"などを取得。
function F_gestion($nomSrv, $file)
{
	if(F_is_file($nomSrv, $file))
	{
		$dir = blindeChemin(dirname($file));
		$dirTop = blindeChemin($_SESSION["ws"]["$nomSrv"]["rootServeur"]."/".$_SESSION["ws"]["$nomSrv"]["repServeur"]);
		if(!preg_match("@$dirTop@", $dir)){ $dir = $dirTop; }
	}
	else
	{ $dir = $file; }

	if(F_is_FTPServeur($nomSrv))
	{
		$permFile = gestionFTP($nomSrv, $file);
		$permGlob = ($dir == $file) ? $permFile : gestionFTP($nomSrv, $dir);
	}
	else
	{
		$permFile = gestionLocal($file);
		$permGlob = ($dir == $file) ? $permFile : gestionLocal($dir);
	}
	if($permFile != $permGlob){ $permFile = preg_replace("@([^$permGlob]*)@", "", $permFile); }
	if(!$permFile){ $permFile = "N"; }
	return $permFile;
}

//// 通常の(ローカルの)サーバーの場合のパーミッションを取得する。
//// ファイル名を渡しこちらでfileperms()を取得するように変更。(is_readable(), is_writable()を判定に加えたため。)
// 注意：WebShareで作成したファイル以外(httpdが所有者でないもの)の判定は実際と一致しないかもしれない。
// Retourne les droits d'un fichier ou d'un dossier selon l'utilisateur
function gestionLocal($file)
{
	$file  = blindeChemin($file);
	$perms = fileperms($file);
	$iciPerm = "";
	switch($_SESSION["ws"]["typeUser"])
	{
		case 1: // Propriétaire：所有者
			if(is_readable($file) && ($perms & 0400) && ($_SESSION["ws"]["auth1"] == "on")){ $iciPerm .= 'R'; }
			if(is_writable($file) && ($perms & 0200) && ($_SESSION["ws"]["auth3"] == "on")){ $iciPerm .= 'W'; }
		break;

		case 2: // Groupe：グループ
			if(is_readable($file) && ($perms & 0400) && ($perms & 0040) && ($_SESSION["ws"]["auth1"] == "on")){ $iciPerm .= 'R'; }
			if(is_writable($file) && ($perms & 0200) && ($perms & 0020) && ($_SESSION["ws"]["auth3"] == "on")){ $iciPerm .= 'W'; }
		break;

		case 3:
		default: // Tous：その他
			if(is_readable($file) && ($perms & 0400) && ($perms & 0004) && ($_SESSION["ws"]["auth1"] == "on")){ $iciPerm .= 'R'; }
			if(is_writable($file) && ($perms & 0200) && ($perms & 0002) && ($_SESSION["ws"]["auth3"] == "on")){ $iciPerm .= 'W'; }
		break;
	}
	if(empty($iciPerm)){ $iciPerm="N"; }
	return $iciPerm;
}

function gestionFTP($nomSrv, $path)
{
	$path = blindeChemin($path); //// 念のため。
	if(empty($path) || $path == '/') //// これはトップ。
	{
		if(!empty($_SESSION["ws"]["$nomSrv"]["permServeur"]))
		{ return $_SESSION["ws"]["$nomSrv"]["permServeur"]; }
		else //// トップは実際書き込んで読み出してみないとわからない。
		{
			if(B_ftp_rawlist($nomSrv, '/') === FALSE) //// 読み出せないなら書込もさせない。
			{ return($_SESSION["ws"]["$nomSrv"]["permServeur"] = "N"); }
			else
			{
				$iciPerm = "R";
				$testFile = tempnam($_SESSION["ws"]["tempDir"], "test_");
				file_put_contents($testFile, "test");
				if(ftp_put($_SESSION["ws"]["$nomSrv"]["connexion"], "/wstest", $testFile, FTP_BINARY) !== FALSE)
				{ //// テスト書込なのでB_ftp_update()はいらない。
					$iciPerm = "RW";
					ftp_delete($_SESSION["ws"]["$nomSrv"]["connexion"], "/wstest");
				}
				unlink($testFile);
				$_SESSION["ws"]["$nomSrv"]["permServeur"] = $iciPerm;
			}
		}
		return $iciPerm;
	}

	$iciPerm = "N";
	$dir  = dirname($path);
	$file = filename($path);
  if(($contents = B_ftp_rawlist($nomSrv, $dir)) !== FALSE)
	{
    foreach($contents as $line)
		{
      $info = array();
      $vinfo = preg_split("@[\s]+@u", $line, 9);
      if($vinfo[0] !== "total")
			{
        $fileperms = $vinfo[0];
        $filename  = $vinfo[8];
				if($file == $filename){ return permFTP($fileperms); }
      }
    }
  }
	return $iciPerm;
}

//// FTPサーバーの場合のパーミッションを取得する。こちらはperms情報を渡す。
// Retourne les droits FTP d'un fichier ou d'un dossier selon l'utilisateur
function permFTP($perms)
{
	$iciPerm = "";
	switch($_SESSION["ws"]["typeUser"])
	{
		case 1: // Propriétaire
			if((substr($perms, 1, 1) == "r") && ($_SESSION["ws"]["auth1"] == "on")){ $iciPerm .= 'R'; }
			if((substr($perms, 2, 1) == "w") && ($_SESSION["ws"]["auth3"] == "on")){ $iciPerm .= 'W'; }
			break;

		case 2: // Groupe
			if((substr($perms, 4, 1) == "r") && ($_SESSION["ws"]["auth1"] == "on")){ $iciPerm .= 'R'; }
			if((substr($perms, 5, 1) == "w") && ($_SESSION["ws"]["auth3"] == "on")){ $iciPerm .= 'W'; }
			break;

		case 3:
		default: // Tous
			if((substr($perms, 7, 1) == "r") && ($_SESSION["ws"]["auth1"] == "on")){ $iciPerm .= 'R'; }
			if((substr($perms, 8, 1) == "w") && ($_SESSION["ws"]["auth3"] == "on")){ $iciPerm .= 'W'; }
			break;
	}
	if(empty($iciPerm)){ $iciPerm="N"; }
	return $iciPerm;
}


// Dézippe un fichier
function dezipper($nomElement, $nomDestination)
{
	include_once "zip.lib.php";
	$zip = zip_open(blindeChemin($nomElement));
	if($zip)
	{
		while($zip_entry = zip_read($zip))
		{
			$filepath = str_replace("%2F", "/", rawurlencode(dirname(zip_entry_name($zip_entry))));
			$filename = rawurlencode(filename(zip_entry_name($zip_entry)));
			$filepath = str_replace("+", " ", preg_replace('~%([0-9a-f])([0-9a-f])~uei', 'ascToUtf8(hexdec("\\1\\2"))', $filepath));
			$filename = str_replace("+", " ", preg_replace('~%([0-9a-f])([0-9a-f])~uei', 'ascToUtf8(hexdec("\\1\\2"))', $filename));
			$taille = zip_entry_filesize($zip_entry);
			if(!is_dir(blindeChemin($nomDestination."/".$filepath))) { mkdir(blindeChemin($nomDestination."/".$filepath)); }
			if(isset($filename) && !empty($filename) && (strstr(html_entity_decode($filename), "..") === FALSE) && !preg_match($_SESSION["ws"]["varsUser"], html_entity_decode($filename)))
			{
				if($taille != 0)
				{
					if(zip_entry_open($zip, $zip_entry, "r"))
					{
						if(!($handle = fopen(blindeChemin("$nomDestination/$filepath/".$filename), 'w+')))
						{
							return " msginfo=\"".$_SESSION["ws"]["dia"]["cantOpen"]." (".blindeChemin("$nomDestination/$filepath/$filename").")\";";
						}
						if(fwrite($handle, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry))) === FALSE)
						{
							return " msginfo=\"".$_SESSION["ws"]["dia"]["cantwrite"]." (".blindeChemin("$nomDestination/$filepath/$filename").")\";";
						}
						fclose($handle);
						zip_entry_close($zip_entry);
					}
				}
			}
		}
		zip_close($zip);
	}
}


$erreur = "";
$old_error_handler = set_error_handler("myErrorHandler");

// Fonction de gestion des erreurs
function myErrorHandler($errno, $errstr, $errfile, $errline)
{
	global $erreur;

	if((preg_match("@Permission denied@", $errstr)))
	{ $erreur = @$_SESSION["ws"]["dia"]["prohibited"]; }
	elseif((preg_match("@File exist@", $errstr)))
	{ $erreur = @$_SESSION["ws"]["dia"]["fileExist"]; }
	else
	{ $erreur= @$_SESSION["ws"]["dia"]["identProblem2"]; }
////	$erreur = $errstr; //////
}


// Fonction de retour de la langue du navigateur
function deflang()
{
	switch(strtolower(substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2)))
	{
		case "ja" : $deflang='Japanese';  break;
		case "jp" : $deflang='Japanese';  break;
		case "fr" : $deflang='Francais';  break;
		case "us" : $deflang='English';   break;
		case "en" : $deflang='English';   break;
		case "de" : $deflang='Deutsch';   break;
		case "pt" : $deflang='Portugues'; break;
		case "br" : $deflang='Portugues'; break;
		case "es" : $deflang='Spanish';   break;
		case "ca" : $deflang='Catalan';   break;
		case "zh" : $deflang='Chinese';   break;
		case "ko" : $deflang='Korean';    break;
		default   : $deflang='English';   break;
	}
	return $deflang;
}


//// ftpサーバーに接続する。
// Fonction de connexion à un serveur FTP
function connexionFTP($nomFTP)
{
	if(!isset($_SESSION["ws"]["$nomFTP"]["connexionCount"]))
	{ $_SESSION["ws"]["$nomFTP"]["connexionCount"] = 0; }
	if($_SESSION["ws"]["$nomFTP"]["connexionCount"] && $_SESSION["ws"]["$nomFTP"]["connexion"])
	{
		++$_SESSION["ws"]["$nomFTP"]["connexionCount"];
		return $_SESSION["ws"]["$nomFTP"]["connexion"];
	}
	$conn_id = ftp_connect($_SESSION["ws"]["$nomFTP"]["adrServeur"], (int)$_SESSION["ws"]["$nomFTP"]["portServeur"], 10);
	if(!$conn_id){ return(NULL); }
	$login_result = ftp_login($conn_id, $_SESSION["ws"]["$nomFTP"]["logServeur"], base64_decode($_SESSION["ws"]["$nomFTP"]["passServeur"]));
	if(!$login_result){ return(NULL); }
	ftp_pasv($conn_id, FTP_PASSIVE); //// 追加してみる。PASSIVEモードのほうがいいようだ。
	++$_SESSION["ws"]["$nomFTP"]["connexionCount"];
	return($_SESSION["ws"]["$nomFTP"]["connexion"] = $conn_id);
}

function closeFTP($nomFTP)
{
	if(--$_SESSION["ws"]["$nomFTP"]["connexionCount"] < 1)
	{
		if($_SESSION["ws"]["$nomFTP"]["connexion"])
		{
			ftp_close($_SESSION["ws"]["$nomFTP"]["connexion"]);
			$_SESSION["ws"]["$nomFTP"]["connexion"] = NULL;
		}
	}
	return(NULL);
}

// Fonction de récupération des informations d'un fichier sur serveur FTP
function ftp_recup_fileinfo($nomSrv, $cheminGlobal)
{
	$cheminFichier = blindeChemin($_SESSION["ws"]["$nomSrv"]["rootServeur"].dirname($cheminGlobal));
	$tabInfos = array();
	$contents = B_ftp_rawlist($nomSrv, $cheminFichier);
	if($contents !== FALSE)
	{
		foreach($contents as $entry)
		{
			$info = array();
			$vinfo = preg_split("@[\s]+@u", $entry, 9);
			if(!preg_match($_SESSION["ws"]["varsUser"], $vinfo[8]) && (trim($vinfo[8]) == filename($cheminGlobal)))
			{
				if($vinfo[0] !== "total")
				{
					$info['chmod'] = trim($vinfo[0]);
					$info['num']   = trim($vinfo[1]);
					$info['owner'] = trim($vinfo[2]);
					$info['group'] = trim($vinfo[3]);
					$info['size']  = trim($vinfo[4]);
					$info['month'] = trim($vinfo[5]);
					$info['day']   = trim($vinfo[6]);
					$info['time']  = trim($vinfo[7]);
					$info['name']  = trim($vinfo[8]);
				}
				$tabInfos["iciPerm"] = permFTP($info['chmod']);
				$tabInfos["modif"]   = $info['day']." ".$info['month']." ".$info['time'];
				if(strpos($info['chmod'],"d") !== FALSE)
				{
					$tabInfos["proto"]  = "dossier";
					$tabInfos["taille"] = 0;
				}
				else
				{
					$tabInfos["proto"]  = "local";
					$tabInfos["taille"] = $info['size'];
				}
				if(strpos($info['chmod'], "l") !== FALSE)
				{
					$symLink = explode(" ->", $info['name']);
					$info['name'] = $symLink[0];
				}
				return $tabInfos;
			}
		}
	}
	return FALSE;
}


mb_internal_encoding("UTF-8");
mb_regex_encoding("UTF-8");

// Conversion en UTF8
function convertUTF8($str)
{
	if(function_exists('mb_convert_encoding') && function_exists('mb_detect_encoding'))
	{
		return mb_convert_encoding($str, "UTF-8", mb_detect_encoding($str)); //// ちゃんと変換できるようmb_detect_encodingを追加し書き変えた
	}
	else
	{
		return utf8_encode($str);
	}
}

// Convertion de l'extended ASCII vers l'UTF8
function ascToUtf8($val)
{
	$convertTable = array(
 "128"=>"Ç", "129"=>"ü", "130"=>"é", "131"=>"â", "132"=>"ä", "133"=>"à", "135"=>"ç", "136"=>"ê",
 "137"=>"ë", "138"=>"è", "139"=>"ï", "140"=>"î", "141"=>"ì", "142"=>"Ä", "143"=>"Å", "144"=>"É",
 "145"=>"æ", "146"=>"Æ", "147"=>"ô", "148"=>"ö", "149"=>"ò", "150"=>"û", "151"=>"ù", "152"=>"ÿ",
 "153"=>"Ö", "154"=>"Ü", "160"=>"á", "161"=>"í", "162"=>"ó", "163"=>"ú", "164"=>"ñ", "165"=>"Ñ",
 "167"=>"°", "248"=>"°");
	return $convertTable[$val];
}

//// convCar()の逆
//// javascriptのescape(), convertURI(), phpのrawurlencode()のいずれの結果もUTF-8に変換可能。
function urlToUtf8($str)
{
	$str = preg_replace("@%u([0-9a-f]{3,4})@i", "&#x\\1;", rawurldecode($str));
	return html_entity_decode($str, null, 'UTF-8');
}

// Convertion de l'unicode javascript vers l'UTF8
function jsToUtf8($val)
{
	return preg_replace("@%u([0-9ABCDEFabcdef]{3,5})@ue", 'html_to_utf8("\\1")', rawurldecode($val));
}

function html_to_utf8($data)
{
	$data = hexdec($data);
	if($data > 127)
	{
		$i = 5;
		while(($i--) > 0)
		{
			if($data != ($a = $data % ($p = pow(64, $i))))
			{
				$ret = chr(base_convert(str_pad(str_repeat(1, $i + 1), 8, "0"), 2, 10) + (($data - $a) / $p));
				for($i; $i > 0; $i--)
				{
					$ret .= chr(128 + ((($data % pow(64, $i)) - ($data % ($p = pow(64, $i - 1)))) / $p));
				}
				break;
			}
		}
	}
	else
	{
		$ret = "&#$data;";
	}
	return $ret;
}

//// マルチバイト文字についてjavascriptのescape()の変換と類似の変換をする。
//// ただしASCII記号文字部分の変換はしない。
// Fonction de conversion des caractères tapés par l'utilisateur
// pour insertion dans le nom de fichier même si le serveur est incompatible
function convCar($str)
{
	if(!ESCAPE_FILENAME)
	{
		return urlToUtf8($str);
	}
	elseif(function_exists('mb_convert_encoding'))
	{
		$result = unistr_to_ords($str);
		$nomCorrige = "";
		foreach($result as $valCar)
		{
			if($valCar <= 255){ $nomCorrige .= chr($valCar); }
			else              { $nomCorrige .= "%u".strtoupper(dechex($valCar)); }
		}
		return($nomCorrige);
	}
	else
	{ return $str; }
}
// Turns a string of unicode characters into an array of ordinal values,
// Even if some of those characters are multibyte.
function unistr_to_ords($str, $encoding='UTF-8')
{
	$str = mb_convert_encoding($str, "UCS-4BE", $encoding);
	$ords = array();
	// Visit each unicode character
	for($i = 0; $i < mb_strlen($str, "UCS-4BE"); $i++)
	{
		// Now we have 4 bytes. Find their total numeric value.
		$s2 = mb_substr($str, $i, 1, "UCS-4BE");
		$val = unpack("N", $s2);
		$ords[] = $val[1];
	}
	return($ords);
}

// Conversion des tailles de fichiers
function conversion($val)
{
	$val = trim($val);
	$last = strtolower($val{strlen($val)-1});
	switch($last)
	{
		case 'g': $val *= 1024;
		case 'm': $val *= 1024;
		case 'k': $val *= 1024;
		break;
	}
	return $val;
}


// Fonction de coloration syntaxique
function ColorPhpCode($Code)
{
	$Color['html']    = '#000000';
	$Color['comment'] = '#008080';
	$Color['default'] = '#0000BB';
	$Color['keyword'] = '#007700';
	$Color['string']  = '#FF4000';

	$ret = highlight_string($Code, TRUE);
	$in = array(
		'`</?code>`i',
		'`<(?:font color="|span style="color: )' .ini_get('highlight.html')   . '">(.+?)</(?:font|span)>`si',
		'`<(?:font color="|span style="color: )' .ini_get('highlight.comment'). '">(.+?)</(?:font|span)>`si',
		'`<(?:font color="|span style="color: )' .ini_get('highlight.default'). '">(.+?)</(?:font|span)>`si',
		'`<(?:font color="|span style="color: )' .ini_get('highlight.keyword'). '">(.+?)</(?:font|span)>`si',
		'`<(?:font color="|span style="color: )' .ini_get('highlight.string') . '">(.+?)</(?:font|span)>`si',
		'` `si'
	);
	$out = array(
		'',
		'<span class="html">$1</span>',
		'<span style="color:' .$Color['comment']. '">$1</span>',
		'<span style="color:' .$Color['default']. '">$1</span>',
		'<span style="color:' .$Color['keyword']. '">$1</span>',
		'<span style="color:' .$Color['string' ]. '">$1</span>',
		' '
	);
	$ret= preg_replace($in, $out, $ret);
	$pieces= explode("<br />", $ret);
	$numLigne = 1;
	$ret  = "<table border=0 cellspacing=0 cellpadding=0>\n";
	foreach ($pieces as $valeur)
	{
		$ret.= "<tr><td class='cl'>".$numLigne++."</td><td class='cd'>&nbsp;".$valeur."</td></tr>\n";
	}
	$ret .= "</table>";
	return $ret;
}


// ==== Gestion de la base SQL ====

if(SQL_TYPE == "SQLite2PDO" || SQL_TYPE == "SQLite3PDO") //// GLOBAL Positionに記載しないとだめ。
{
	function exception_handler($exception)
	{
		error_log("SQLite PDO exception: ".$exception->getMessage());
	}
	set_exception_handler('exception_handler');
}


class class_sql
{
	private $pv_connect = NULL;

	// ==== Le constructeur ====
	public function class_sql()
	{
	}

	// ==== Crée la connexion sql ====
	function connect()
	{
		if(SQL_TYPE == "MySQL")
		{
			if($this->pv_connect = mysql_connect($_SESSION["ws"]["serveurBase"], $_SESSION["ws"]["loginBase"], base64_decode($_SESSION["ws"]["passBase"])))
			{
				mysql_select_db($_SESSION["ws"]["tableBase"], $this->pv_connect);
				mysql_query("SET NAMES 'utf8'", $this->pv_connect);
				return TRUE;
			}
		}
		elseif(SQL_TYPE == "SQLite2")
		{
			if($this->pv_connect = @sqlite_open($_SESSION["ws"]["repPass"]."sitedata.sqlite2"))
			{ return TRUE; }
		}
		elseif(SQL_TYPE == "SQLite2PDO")
		{
			if($this->pv_connect = new PDO("sqlite2:".$_SESSION["ws"]["repPass"]."sitedata.sqlite2"))
			{ return TRUE; }
		}
		elseif(SQL_TYPE == "SQLite3PDO")
		{
			if($this->pv_connect = new PDO("sqlite:".$_SESSION["ws"]["repPass"]."sitedata.sqlite3"))
			{ return TRUE; }
		}
		return FALSE;
	}

	// ==== Teste la connexion ====
	function test()
	{
		if(SQL_TYPE == "MySQL")
		{ return @mysql_ping($this->pv_connect); }
		elseif(SQL_TYPE == "SQLite2")
		{ return $this->connect(); }
		elseif(SQL_TYPE == "SQLite2PDO" || SQL_TYPE == "SQLite3PDO")
		{
			if($this->pv_connect === NULL){ $this->connect(); }
			return($this->pv_connect !== NULL);
		}
		return FALSE;
	}

	// ==== Retourne le résultat d'une requête ====
	function request_result($l_query)
	{
		if(!$this->test()) { $this->connect(); }
		if(!empty($l_query) && trim($l_query))
		{
			if(SQL_TYPE == "MySQL"){ $l_ret = mysql_query($l_query, $this->pv_connect); }
			elseif(SQL_TYPE == "SQLite2"){ $l_ret = sqlite_query($this->pv_connect, $l_query); }
			elseif(SQL_TYPE == "SQLite2PDO" || SQL_TYPE == "SQLite3PDO")
			{
				$l_result = array();
				foreach($this->pv_connect->query($l_query, PDO::FETCH_ASSOC) as $assoc)
				{ $l_result[] = $assoc; }
				return $l_result;
			}
			else{ return FALSE; }

			if($l_ret !== FALSE) //// At only "MySQL" and "SQLite2". Not PDO.
			{
				$l_result = Array();
				while($l_row = $this->sql_fetch_array($l_ret))
				{
					foreach($l_row as $l_key => $l_value)
					{ $p_http[$l_key] = $l_value; }
					$l_result[] = $p_http;
				}
				unset($l_ret);
				return $l_result;
			}
			else
			{
				error_log($this->error()); ////
				error_log("Errord query=".$l_query."\n"); ////
				return FALSE;
			}
		}
		return FALSE;
	}

	function sql_fetch_array($l_ret) //// At only "MySQL" and "SQLite2". Not use for PDO.
	{
		if(SQL_TYPE == "MySQL"){ $f_ary = mysql_fetch_array($l_ret); }
		elseif(SQL_TYPE == "SQLite2"){ $f_ary = sqlite_fetch_array($l_ret); }
		else{ return FALSE; }
		return $f_ary;
	}

	// ==== Effectue une requête sans réponse ====
	function request($l_query)
	{
		if(!$this->test()){ $this->connect(); }
		if(!empty($l_query) && trim($l_query))
		{
			if(SQL_TYPE == "MySQL"){ $l_ret = mysql_query($l_query, $this->pv_connect); }
			elseif(SQL_TYPE == "SQLite2"){ $l_ret = sqlite_query($this->pv_connect, $l_query); }
			elseif(SQL_TYPE == "SQLite2PDO" || SQL_TYPE == "SQLite3PDO"){ $l_ret = $this->pv_connect->exec($l_query); }
			else{ return FALSE; }

			if($l_ret !== FALSE)
			{ return TRUE; }
			else
			{
				error_log($this->error()); ////
				error_log("Errord query=".$l_query."\n"); ////
				return FALSE;
			}
		}
		return FALSE;
	}

	// ==== Déconnexion ====
	function disconnect()
	{
		if(SQL_TYPE == 'MySQL')
		{ mysql_close($this->pv_connect); }
		elseif(SQL_TYPE == "SQLite2")
		{ sqlite_close($this->pv_connect); }
		unset($this->pv_connect);
		$this->pv_connect = NULL;
	}

	// ==== Erreur ====
	function error()
	{
		if(SQL_TYPE == "None"){ return ""; }
		$errmsg = "L'erreur renvoyée par ".SQL_TYPE." est : ";
		if(SQL_TYPE == "MySQL")
		{ $errmsg .= mysql_error($this->pv_connect); }
		elseif(SQL_TYPE == "SQLite2")
		{ $errmsg .= sqlite_error_string(sqlite_last_error($this->pv_connect)); }
		elseif(SQL_TYPE == "SQLite2PDO" || SQL_TYPE == "SQLite3PDO")
		{ $msgary = $this->pv_connect->errorInfo(); $errmsg .= $msgary[2]; }
		else
		{ $errmsg .= "Not Valid SQL Type."; }
		return $errmsg;
	}

/*
	function sql_escape_string($value)
	{ //// PDOのquoteとかはだめ。
		if(SQL_TYPE == "MySQL")
		{
			$value = mb_ereg_replace('(\x00|\n|\r|\\\\|"|\'|\x1a)', '\\\1', $value);
		}
		else
		{
			// sqliteの必要なescapeがこれでいいのかよくわからない。ごめん。
			$value = mb_ereg_replace("'", "''", $value);
			$value = mb_ereg_replace('\x00|\x01', '', $value);
		}
		return $value;
	}
*/ //////
	function sql_escape_string($value)
	{
		if(SQL_TYPE == "MySQL")
		{
			$value = mysql_escape_string($value);
		}
		elseif(SQL_Type == "SQLite2")
		{
			$value = sqlite_escape_string($value);
		}
		else
		{
			// これでいいのかよくわからない。ごめん。
			$value = mb_ereg_replace("'", "''", $value);
		}
		return $value;
	}


	// ==== Blinde les données SQL ====
	function blinde_param($p_param)
	{
		foreach($p_param as $l_key => $l_value)
		{
			if(is_string($l_value) && ($l_value == ""))
			{ $p_http[$l_key] = ""; }
			elseif(is_string($l_value))
			{ $p_http[$l_key] = $this->sql_escape_string(stripslashes($l_value)); }
			elseif(is_array($l_value))
			{ $p_http[$l_key] = $this->blinde_param($l_value); }
		}
		return $p_http;
	}

	// ==== Log des actions ====
	function logAction($tabLog)
	{
		if($_SESSION["ws"]["activeLog"] == 1)
		{
			$tabLog["idaction"] =          $tabLog["0"];
			$tabLog["idresult"] =          $tabLog["1"];
			$tabLog["verbose"]  = jsToUtf8($tabLog["2"]);
			$tabLog["username"] =          $tabLog["3"];
			$tabLog["path"]     = jsToUtf8($tabLog["4"]);
			$tabLog["file"]     = jsToUtf8($tabLog["5"]);
			$tabLog["content"]  =          $tabLog["6"];
			$ipadr = $_SERVER['REMOTE_ADDR'];
			if($this->test()) //// SQL OK
			{
				$tabLog = $this->blinde_param($tabLog);

				// ==== Ajout de l'action dans la base de données de log ====
				$request =
 "INSERT INTO wslog (idaction,idresult,iddate,verbose,username,path,file,content,ipadr)
 VALUES('$tabLog[idaction]','$tabLog[idresult]','".date("Y-m-d H:i:s")."',"
."'$tabLog[verbose]','$tabLog[username]','$tabLog[path]','$tabLog[file]','$tabLog[content]','$ipadr') ";
				$result = $this->request($request);
				//// ログの件数をチェックし、多過ぎれば削除
				$max_rows = SQL_LOG_MAX; //// 定義wspasswd/define.phpに。
				$selectResult = $this->request_result("SELECT iddate FROM wslog ORDER BY iddate ASC");
				$wslog_rows = count($selectResult);
				if($wslog_rows > $max_rows) //// なくてもいいが毎回OPTIMIZEが実行されてしまうので。
				{
					$row = 0;
					while($wslog_rows-- > $max_rows)
					{
						$iddate = $selectResult[$row++]["iddate"];
						$deleteQuery  = "DELETE FROM wslog WHERE iddate = '".$iddate."'"; //// 古いのを消す
						$this->request($deleteQuery);
					}
				}
			}
			elseif(isset($_SESSION["ws"]["repLog"]))
			{
				// ==== Ajout de l'action dans le fichier texte de log ====
				if(($dest = fopen($_SESSION["ws"]["repLog"]."logs-".date("Ymd").".txt", "a+")) === FALSE)
				{
					$erreur = 1;
				}
				else
				{
					$erreur = 0;
					fwrite($dest, date("Y-m-d H:i:s")." / ".$tabLog["username"]." ($ipadr) : ".$tabLog["verbose"]."\n");
					fclose($dest);
				}
			}
		}
	}
}
class class_mysql extends class_sql{} // For legacy plugin.


//// 追加
function F_copieScandir($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin)
{
	if(F_is_FTPServeur($nomSrvDepart))
	{
		if(F_is_FTPServeur($nomSrvDestin))
		{ return copieScandirFTP($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin); }
		else
		{ return copieScandirFromFTP($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin); }
	}
	else
	{
		if(F_is_FTPServeur($nomSrvDestin))
		{ return copieScandirToFTP($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin); }
		else
		{ return copieScandir($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin); }
	}
}

//// 新規。FTP同士で(あるいはFTP内で)コピー。
function copieScandirFTP($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin)
{
	if(!ensure_FTPdirpath($nomSrvDestin, $cheminDestin))
	{ return FALSE; }

	$cheminTemp = tempnam($_SESSION["ws"]["tempDir"], "TEMP_");
	unlink($cheminTemp);
	mkdir($cheminTemp);
	if(copieScandirFromFTP($nomSrvDepart, $cheminDepart, "wstemp", $cheminTemp) === FALSE
		|| copieScandirToFTP("wstemp", $cheminTemp, $nomSrvDestin, $cheminDestin) === FALSE)
	{
		removeScandir("wstemp", $cheminTemp);
		return FALSE;
	}
	else
	{
		removeScandir("wstemp", $cheminTemp);
		return TRUE;
	}
}

//// こちらに移動。
//// FTPサーバーのディレクトリと内容をローカルにコピーする。
// Fonction de copie récursive à partir du FTP
function copieScandirFromFTP($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin)
{
	if(is_file($cheminDestin) || !ensure_dirpath($cheminDestin))
	{ return FALSE; }

	$result = TRUE;
	if(($contents = B_ftp_rawlist($nomSrvDepart, blindeChemin($cheminDepart))) !== FALSE)
	{
		foreach($contents as $file)
		{
			if(preg_match("@^(?:[.]{2}|[.]{1}|wsminis)$@u", $file)){ continue; }
			$info = array();
			$vinfo = preg_split("@[\s]+@u", $file, 9);
			if($vinfo[0] !== "total")
			{
				$fileperms = $vinfo[0];
				$filename  = $vinfo[8];
			}
			$_SESSION["ws"]["progress"] = $filename;
			if(strpos($fileperms, "d") !== FALSE)
			{
				$result &= copieScandirFromFTP($nomSrvDepart, "$cheminDepart/$filename", $nomSrvDestin, "$cheminDestin/$filename");
			}
			else
			{
				if(($result &= ftp_get($_SESSION["ws"]["$nomSrvDepart"]["connexion"], "$cheminDestin/$filename", "$cheminDepart/$filename", FTP_BINARY)) !== FALSE)
				{
					chmod("$cheminDestin/$filename", NEWFILE_PERM);
					moveMiniComFav($nomSrvDepart, "$cheminDepart/$filename", 'copy', $nomSrvDestin, "$cheminDestin/$filename");
				}
			}
			if(!$result){ return FALSE; }
		}
		moveMiniComFav($nomSrvDepart, $cheminDepart, 'copy', $nomSrvDestin, $cheminDestin);
	}
	else{ return FALSE; }
	return TRUE;
}

//// ローカルからFTPへディレクトリをそっくりコピーする。
// Fonction de copie récursive vers le FTP
function copieScandirToFTP($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin)
{
	if(!ensure_FTPdirpath($nomSrvDestin, $cheminDestin))
	{ return FALSE; }

	$result = TRUE;
	if($handle = opendir(blindeChemin("$cheminDepart")))
	{
		while(($file = readdir($handle)) !== FALSE)
		{
			if(preg_match("@^(?:[.]{2}|[.]{1}|wsminis)$@u", $file)){ continue; }
			$_SESSION["ws"]["progress"] = $file;
			if(is_dir("$cheminDepart/$file"))
			{
				$result &= copieScandirToFTP($nomSrvDepart, "$cheminDepart/$file", $nomSrvDestin, "$cheminDestin/$file");
			}
			else
			{
				B_ftp_update($nomSrvDestin);
				if($result &= ensure_FTPfilepath($nomSrvDestin, "$cheminDestin/$file"))
				{
					if($result &= @ftp_put($_SESSION["ws"]["$nomSrvDestin"]["connexion"], "$cheminDestin/$file", "$cheminDepart/$file", FTP_BINARY))
					{
						@ftp_chmod($_SESSION["ws"]["$nomSrvDestin"]["connexion"], NEWFTPFILE_PERM, "$cheminDestin/$file");
						moveMiniComFav($nomSrvDepart, "$cheminDepart/$file", 'copy', $nomSrvDestin, "$cheminDestin/$file");
					}
				}
			}
			if(!$result){ break; }
		}
		closedir($handle);
		if(!$result){ return FALSE; }
		moveMiniComFav($nomSrvDepart, $cheminDepart, 'copy', $nomSrvDestin, $cheminDestin);
	}
	else{ return FALSE; }
	return TRUE;
}

//// ローカルサーバー内でディレクトリをそっくりコピーする。
// Fonction de copie récursive
function copieScandir($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin)
{
	if(is_file($cheminDestin) || !ensure_dirpath($cheminDestin))
	{ return FALSE; }

	$result = TRUE;
	if($handle = opendir(blindeChemin($cheminDepart)))
	{
		while(($file = readdir($handle)) !== FALSE)
		{
			if(preg_match("@^(?:[.]{2}|[.]{1}|wsminis)$@u", $file)){ continue; }
			$_SESSION["ws"]["progress"] = $file;
			if(is_dir("$cheminDepart/$file"))
			{
				$result &= copieScandir($nomSrvDepart, "$cheminDepart/$file", $nomSrvDestin, "$cheminDestin/$file");
			}
			else
			{
				if($result &= copy("$cheminDepart/$file", "$cheminDestin/$file"))
				{
					chmod("$cheminDestin/$file", NEWFILE_PERM);
					moveMiniComFav($nomSrvDepart, "$cheminDepart/$file", 'copy', $nomSrvDestin, "$cheminDestin/$file");
				}
			}
			if(!$result){ break; }
		}
		closedir($handle);
		if(!$result)
		{ return(FALSE); }
		moveMiniComFav($nomSrvDepart, $cheminDepart, 'copy', $nomSrvDestin, $cheminDestin);
	}
	else{ return FALSE; }
	return TRUE;
}

//// 追加
function F_removeScandir($nomSrvDepart, $cheminDepart, $withMiniComFav=TRUE)
{
	if(F_is_FTPServeur($nomSrvDepart))
	{ return removeScandirFTP($nomSrvDepart, $cheminDepart, $withMiniComFav); }
	else
	{ return removeScandir($nomSrvDepart, $cheminDepart, $withMiniComFav); }
}

//// FTPのディレクトリをそっくり削除する。
// Fonction de suppression récursive sur le FTP
function removeScandirFTP($nomSrvDepart, $cheminDepart, $withMiniComFav=TRUE)
{
	if(($contents = B_ftp_rawlist($nomSrvDepart, $cheminDepart)) !== FALSE)
	{
		foreach($contents as $file)
		{
			if(preg_match("@^(?:[.]{2}|[.]{1}".($withMiniComFav?"":"|wsminis").")$@u", $file)){ continue; }
			$info  = array();
			$vinfo = preg_split("@[\s]+@u", $file, 9);
			if($vinfo[0] !== "total")
			{
				$fileperms = $vinfo[0];
				$filename  = $vinfo[8];
			}
			$_SESSION["ws"]["progress"] = $filename;
			if(strpos($fileperms, "d") !== FALSE)
			{
				if(removeScandirFTP($nomSrvDepart, "$cheminDepart/$filename", $withMiniComFav) === FALSE)
				{ return FALSE; }
			}
			else
			{
				if(@ftp_delete($_SESSION["ws"]["$nomSrvDepart"]["connexion"], "$cheminDepart/$filename") === FALSE)
				{ return FALSE; }
				if($withMiniComFav)
				{ moveMiniComFav($nomSrvDepart, "$cheminDepart/$filename", 'delete'); }
			}
		}
		B_ftp_update($nomSrvDepart);
		if(@ftp_rmdir($_SESSION["ws"]["$nomSrvDepart"]["connexion"], $cheminDepart) === FALSE)
		{ return FALSE; }
		if($withMiniComFav){ moveMiniComFav($nomSrvDepart, $cheminDepart, 'delete'); }
	}
	else{ return FALSE; }
	return TRUE; //// 本当はちゃんとチェックしたほうがいいのだが。
}

//// ローカルサーバー内の指定ディレクトリをそっくり削除する。
// Fonction de suppression récursive
function removeScandir($nomSrvDepart, $cheminDepart, $withMiniComFav=TRUE)
{
	if($handle = opendir($cheminDepart))
	{
		while(($file = readdir($handle)) !== FALSE)
		{
			if(preg_match("@^(?:[.]{2}|[.]{1}".($withMiniComFav?"":"|wsminis").")$@u", $file))
			{ continue; }
			$_SESSION["ws"]["progress"] = $file;
			if(is_dir("$cheminDepart/$file"))
			{
				if(removeScandir($nomSrvDepart, "$cheminDepart/$file", $withMiniComFav) === FALSE)
				{
					closedir($handle);
					return FALSE;
				}
			}
			elseif(unlink("$cheminDepart/$file") === FALSE)
			{
				closedir($handle);
				return FALSE;
			}
			else
			{
				if($withMiniComFav){ moveMiniComFav($nomSrvDepart, "$cheminDepart/$file", 'delete'); }
			}
		}
		closedir($handle);
		if(rmdir($cheminDepart) === FALSE)
		{ return FALSE; }
		if($withMiniComFav){ moveMiniComFav($nomSrvDepart, $cheminDepart, 'delete'); }
	}
	return(!is_dir($cheminDepart) && !is_file($cheminDepart)); //// 最初から空でもOKとする。
}

//// 以下追加

//// ファイルへのディレクトリパスを作成する。
function ensure_filepath($filepath, $dirperm=NEWDIR_PERM)
{
	if($filepath){ return ensure_dirpath(dirname($filepath), $dirperm); }
	else{ return FALSE; }
}

function ensure_dirpath($dirpath, $dirperm=NEWDIR_PERM)
{
	//// いきなりmkdir()やexec('mkdir -m 0775 -p '.$dirpath);だと途中のパーミッションが指定通りならない。
	$dirname_array = mb_split('/', $dirpath);
	$workpath = '';
	foreach($dirname_array as $dirname)
	{
		if($dirname=='' || $dirname=='.'){continue;}
		if(empty($workpath))
		{ $workpath = (substr($dirpath, 0, 1) == '/' ? '/' : '').$dirname; } //// 絶対、相対パス考慮
		else
		{ $workpath .= '/'.$dirname; }
		if(is_file($workpath))
		{ return FALSE; }
		if(!is_dir($workpath))
		{
			if(mkdir($workpath))
			{ chmod($workpath, $dirperm); }
			else
			{ return FALSE; }
		}
	}
	return is_dir($dirpath);
}

//// FTPファイルへのディレクトリパスを作成する。
function ensure_FTPfilepath($nomSrv, $filepath, $dirperm=NEWFTPDIR_PERM)
{
	if($filepath)
	{
		$dirpath = dirname($filepath);
		return(ensure_FTPdirpath($nomSrv, $dirpath, $dirperm));
	}
	else
	{ return FALSE; }
}
//// FTPディレクトリパスを作成する。
function ensure_FTPdirpath($nomSrv, $dirpath, $dirperm=NEWFTPDIR_PERM)
{
	$dirname_array = mb_split('/', $dirpath);
	$workpath = '';
	$ftp_connexion = $_SESSION["ws"]["$nomSrv"]["connexion"];
	B_ftp_update($nomSrv);
	foreach($dirname_array as $dirname)
	{
		if($dirname==''||$dirname=='.'){ continue; }
		$workpath .= '/'.$dirname;
		if(!ftp_chdir($ftp_connexion, $workpath))
		{
			if(@ftp_mkdir($ftp_connexion, $workpath) !== FALSE)
			{  @ftp_chmod($ftp_connexion, $dirperm, $workpath); }
			else
			{ return FALSE; }
		}
		ftp_chdir($ftp_connexion, '/');
	}
	return TRUE;
}


$B_FTP_UPDATED = array();
function B_ftp_update($nomSrv)
{
	global $B_FTP_UPDATED;

	$B_FTP_UPDATED["$nomSrv"]["rawlist"] = 0;
	$B_FTP_UPDATED["$nomSrv"]["contents"] = 0;
}
// Buffered ftp_rawlist
function B_ftp_rawlist($nomSrv, $chemin)
{
	global $B_FTP_UPDATED;
	static $contents = array();

	if(empty($B_FTP_UPDATED["$nomSrv"]["rawlist"]) || (time() - $B_FTP_UPDATED["$nomSrv"]["rawlist"] >= FTP_BUFTIME)
		|| !isset($contents["$nomSrv/$chemin"]))
	{
		$contents["$nomSrv/$chemin"] = @ftp_rawlist($_SESSION["ws"]["$nomSrv"]["connexion"], $chemin);
		$B_FTP_UPDATED["$nomSrv"]["rawlist"] = time();
	}
	return $contents["$nomSrv/$chemin"];
}


//// F_function():FTPとLOCALで共通に使えるように作成。
//// ただしサーバーの判定用にサーバー名が必要。FTPサーバー以外すべてLOCALと判定。
function F_is_FTPServeur($nomSrv)
{
	if($nomSrv == "wstemp" || $nomSrv == "wssite"){ return FALSE; }
	if($nomSrv && isset($_SESSION["ws"]["$nomSrv"]["typeServeur"]) && $_SESSION["ws"]["$nomSrv"]["typeServeur"] == 2){ return TRUE; }
	return FALSE;
}

function F_mkdir($nomSrv, $chemin)
{
	if(F_is_FTPServeur($nomSrv))
	{
		if(@ftp_mkdir($_SESSION["ws"]["$nomSrv"]["connexion"], $chemin) !== FALSE)
		{
			B_ftp_update($nomSrv);
			return @ftp_chmod($_SESSION["ws"]["$nomSrv"]["connexion"], NEWFTPDIR_PERM, $chemin);
		}
		else{ return FALSE; }
	}
	else
	{
		if(@mkdir($chemin) !== FALSE){ return @chmod($chemin, NEWDIR_PERM); }
		else{ return FALSE; }
	}
}

function F_is_file($nomSrv, $chemin)
{
	if(F_is_FTPServeur($nomSrv))
	{
		if(($contents = B_ftp_rawlist($nomSrv, blindeChemin(dirname($chemin)))) !== FALSE)
		{
			foreach($contents as $file)
			{
				$info = array();
				$vinfo = preg_split("@[\s]+@u", $file, 9);
				if(preg_match("@".filename($chemin)."@u", $vinfo[8])) //// 同じ名前のものがある。
				{
					$fileperms = $vinfo[0];
					$filename  = $vinfo[8];
					if(strpos($fileperms, "d") !== FALSE) //// ファイルではなくディレクトリ
					{ return FALSE; }
					return TRUE;
				}
			}
			return FALSE;
		}
		else{ return FALSE; }
	}
	else{ return(is_file($chemin)); }
}

function F_is_dir($nomSrv, $chemin)
{
	if(F_is_FTPServeur($nomSrv))
	{
		if(($contents = B_ftp_rawlist($nomSrv, blindeChemin(dirname($chemin)))) !== FALSE)
		{
			foreach($contents as $file)
			{
				$info = array();
				$vinfo = preg_split("@[\s]+@u", $file, 9);
				if(preg_match("@".filename($chemin)."@u", $vinfo[8])) //// 同じ名前のものがある。
				{
					$fileperms = $vinfo[0];
					$filename  = $vinfo[8];
					if(strpos($fileperms, "d") !== FALSE) //// ファイルではなくディレクトリ
					{ return TRUE; }
					return FALSE;
				}
			}
			return FALSE;
		}
		else{ return FALSE; }
	}
	else{ return(is_dir($chemin)); }
}

function F_filesize($nomSrv, $chemin)
{
	if(F_is_FTPServeur($nomSrv))
	{
		if(($size = ftp_size($_SESSION["ws"]["$nomSrv"]["connexion"], $chemin)) >= 0)
		{ return $size; }
		else
		{ return FALSE; }
	}
	else
	{ return filesize($chemin); }
}

function F_copy($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin)
{
	$result = TRUE;
	if(F_is_FTPServeur($nomSrvDepart) || F_is_FTPServeur($nomSrvDestin))
	{
		if(($contents = F_get_contents($nomSrvDepart, $cheminDepart)) === FALSE)
		{ return FALSE; }
		$result &= F_put_contents($nomSrvDestin, $cheminDestin, $contents);
	}
	else
	{
		$result &= ensure_filepath($cheminDestin);
		$result &= @copy($cheminDepart, $cheminDestin);
		$result &= @chmod($cheminDestin, NEWFILE_PERM);
	}
	return($result);
}

function F_dirlist($nomSrv, $chemin)
{
	if(F_is_FTPServeur($nomSrv))
	{
		if(($rawlist = B_ftp_rawlist($nomSrv, $chemin)) !== FALSE)
		{
			$contents = array();
			foreach($rawlist as $list)
			{
				$vinfo = preg_split("@[\s]+@u", $list, 9);
				if($vinfo[0] !== "total")
				{
					$contents[] = $vinfo[8];
				}
			}
			return $contents;
		}
		else{ return FALSE; }
	}
	else
	{
		if($handle = opendir($chemin))
		{
			$contents = array();
			while(($file = readdir($handle)) !== FALSE) //// scandir()を使うとphp4では動作しない。
			{
				$contents[] = $file;
			}
			closedir($handle);
			return $contents;
		}
		else{ return FALSE; }
	}
}

function F_readfile($nomSrv, $chemin)
{
	if(F_is_FTPServeur($nomSrv))
	{
		$cheminTemp = tempnam($_SESSION["ws"]["tempDir"], "tmp_");
		if(@ftp_get($_SESSION["ws"]["$nomSrv"]["connexion"], $cheminTemp, $chemin, FTP_BINARY) !== FALSE)
		{ @readfile($cheminTemp); }
		unlink($cheminTemp);
	}
	else
	{
		if(is_file($chemin)) { @readfile($chemin); }
	}
}

function F_get_contents($nomSrv, $chemin)
{
	global $B_FTP_UPDATED;
	static $contents = array();

	if(F_is_FTPServeur($nomSrv)) // Buffered
	{
		if(empty($B_FTP_UPDATED["$nomSrv"]["contents"]) || (time() - $B_FTP_UPDATED["$nomSrv"]["contents"] >= FTP_BUFTIME)
			|| !isset($contents["$nomSrv/$chemin"]))
		{
			$cheminTemp = tempnam($_SESSION["ws"]["tempDir"], "tmp_");
			if(@ftp_get($_SESSION["ws"]["$nomSrv"]["connexion"], $cheminTemp, $chemin, FTP_BINARY) !== FALSE)
			{ $contents["$nomSrv/$chemin"] = @file_get_contents($cheminTemp); }
			else
			{ $contents["$nomSrv/$chemin"] = FALSE; }
			unlink($cheminTemp);
			$B_FTP_UPDATED["$nomSrv"]["contents"] = time();
		}
		return($contents["$nomSrv/$chemin"]);
	}
	else
	{
		if(is_file($chemin)){ return @file_get_contents($chemin); }
		else{ return FALSE; }
	}
}

function F_put_contents($nomSrv, $chemin, $contents)
{
	$result = TRUE;
	$newfile = !F_is_file($nomSrv, $chemin);
	if(F_is_FTPServeur($nomSrv))
	{
		$cheminTemp = tempnam($_SESSION["ws"]["tempDir"], "tmp_");
		$result &= file_put_contents($cheminTemp, $contents);
		B_ftp_update($nomSrv);
		$result &= ensure_FTPfilepath($nomSrv, $chemin);
		$result &= @ftp_put($_SESSION["ws"]["$nomSrv"]["connexion"], $chemin, $cheminTemp, FTP_BINARY);
		if($newfile){ @ftp_chmod($_SESSION["ws"]["$nomSrv"]["connexion"], NEWFTPFILE_PERM, $chemin); }
		unlink($cheminTemp);
	}
	else
	{
		$result &= ensure_filepath($chemin);
		$result &= file_put_contents($chemin, $contents);
		if($newfile){ chmod($chemin, NEWFILE_PERM); }
	}
	return $result;
}

function F_file($nomSrv, $chemin) //// テキストデータを行ごとの配列として取得。
{
	if(F_is_FTPServeur($nomSrv))
	{
		$cheminTemp = tempnam($_SESSION["ws"]["tempDir"], "tmp_");
		if(@ftp_get($_SESSION["ws"]["$nomSrv"]["connexion"], $cheminTemp, $chemin, FTP_BINARY) !== FALSE)
		{ $contents = @file($cheminTemp); }
		else
		{ $contents = FALSE; }
		unlink($cheminTemp);
	}
	else
	{
		if(is_file($chemin)){ $contents = @file($chemin); }
		else{ $contents = FALSE; }
	}
	return($contents);
}

function F_rename($nomSrv, $chemin, $cheminNouveau)
{
	if(F_is_FTPServeur($nomSrv))
	{
		B_ftp_update($nomSrv);
		return @ftp_rename($_SESSION["ws"]["$nomSrv"]["connexion"], $chemin, $cheminNouveau);
	}
	else
	{ return rename($chemin, $cheminNouveau); }
}

function F_delete($nomSrv, $chemin)
{
	if(F_is_FTPServeur($nomSrv))
	{
		B_ftp_update($nomSrv);
		return @ftp_delete($_SESSION["ws"]["$nomSrv"]["connexion"], $chemin);
	}
	else
	{ return unlink($chemin); }
}

function F_unlink($nomSrv, $chemin)
{
	if(F_is_FTPServeur($nomSrv))
	{
		B_ftp_update($nomSrv);
		return @ftp_delete($_SESSION["ws"]["$nomSrv"]["connexion"], $chemin);
	}
	else
	{ return unlink($chemin); }
}

function F_getExtensionFromFile($nomSrv, $chemin)
{
	if(F_is_FTPServeur($nomSrv))
	{
		$cheminTemp = $_SESSION["ws"]["tempDir"].filename($chemin);
		ftp_get($_SESSION["ws"]["$nomSrv"]["connexion"], $cheminTemp, $chemin, FTP_BINARY);
		$extension = getExtensionFromFile($cheminTemp);
		unlink($cheminTemp);
	}
	else
	{ $extension = getExtensionFromFile($chemin); }
	return($extension);
}

// 拡張子がない場合ファイルより取得できるならば。
// ただしLinuxの場合。Windowsで取得できるのかは知らない。
function getExtensionFromFile($chemin)
{
	exec("file --version", $out);
	if(!preg_match("@file-[0-9\.]+@", $out[1])){ return ''; }
	$extension = "";
	$filetype = shell_exec('file -bL "'.$chemin.'"');
	if(preg_match('@^JPEG image@', $filetype)){ $extension = 'jpg'; }
	elseif(preg_match('@^PNG image@', $filetype)){ $extension = 'png'; }
	elseif(preg_match('@^GIF image@', $filetype)){ $extension = 'gif'; }
	elseif(preg_match('@^TIFF image@', $filetype)){ $extension = 'tiff'; }
	elseif(preg_match('@^PC bitmap@', $filetype)){ $extension = 'bmp'; }
	elseif(preg_match('@^PDF document@', $filetype)){ $extension = 'pdf'; }
	elseif(preg_match('@^MPEG sequence$@', $filetype)){ $extension = 'ico'; } //// 動画の場合もあり、その場合後ろに詳細データがつく。
	return($extension);
}

//// moveMiniComFav()のアクションの妥当性をチェック
function moveCheck($nomSrvDepart, $cheminDepart, $action, $nomSrvDestin, $cheminDestin)
{
	if(!($action=='move' || $action=='copy' || $action == 'rename' || $action=='delete')){ return FALSE; }
	if(empty($cheminDepart)){ return FALSE; }
	if($action!='delete' && empty($cheminDestin)){ return FALSE; }
	if(preg_match('@(?:^|/)wsminis|wssite(?:/|$)@u', $cheminDepart)){ return FALSE; }
	return TRUE;
}

function dossierMiniCom($nomSrv, $chemin) //// サムネイルやコメントファイルの入ったディレクトリ。$cheminは元サーバーでの絶対パス。
{
	$chemin = blindeChemin($chemin); //// ねんのため。
	if(USE_wssite) //// データをwebshareサイト内のwssiteに。USE_wssiteはfonctions.phpに定義。
	{
		if($nomSrv == "wstemp") //// 一時ディレクトリ。特別。途中で一時的に作られる。
		{
			$dossier = dirname(preg_replace("@".$_SESSION["ws"]["tempDir"]."@u", "/", $chemin));
			$dossier = blindeChemin("../wssite/$nomSrv/$dossier/");
		}
		elseif($nomSrv == $_SESSION["ws"]["nomCorbeille"]) //// ごみ箱。特別。UTF-8以外のサーバーで日本語の「ごみ箱」だと問題が発生。
		{
			$dossier = dirname(preg_replace("@".$_SESSION["ws"]["repCorbeille"]."@u", "/", $chemin));
			$dossier = blindeChemin("../wssite/Corbeille/$dossier/");
		}
		elseif($nomSrv && !empty($_SESSION["ws"]["$nomSrv"]["rootServeur"])) //// ふつうのサーバー
		{
			$dossier = dirname(preg_replace("@".$_SESSION["ws"]["$nomSrv"]["rootServeur"]."@u", "/", $chemin));
			$dossier = blindeChemin("../wssite/$nomSrv/$dossier/");
		}
		else //// 不明。
		{
			$dossier = dirname($chemin);
			$dossier = blindeChemin("../wssite/UNKNOWN/$dossier/");
		}
	}
	else //// データをサーバーのwsminisに。(従来)
	{ $dossier = blindeChemin(dirname($chemin)."/wsminis/"); }
	return($dossier);
}

function cheminMini($nomSrv, $chemin) //// サムネイルのアドレス
{
	return(dossierMiniCom($nomSrv, $chemin).filename($chemin));
}

function cheminCom($nomSrv, $chemin) //// サムネイルのアドレス
{
	return(dossierMiniCom($nomSrv, $chemin)."_param"); //// ファイル名"_param"はここで決まる。他はダミー。
}

//// サムネイルファイルやコメント、ブックマークを移動またはコピーあるいは削除する(あれば)。
//// $cheminDepart, $cheminDestinは元ファイル(時にディレクトリ)への絶対パス。
//// 元があるかなどわからないのでいちいちエラーは返さない。
//// actionは"move","copy","rename","delete"
function moveMiniComFav($nomSrvDepart, $cheminDepart, $action='', $nomSrvDestin='', $cheminDestin='')
{
	if(!moveCheck($nomSrvDepart, $cheminDepart, $action, $nomSrvDestin, $cheminDestin)){ return; }

	//// サムネイル。
	moveMini($nomSrvDepart, $cheminDepart, $action, $nomSrvDestin, $cheminDestin);
	//// コメント。
	moveCom($nomSrvDepart, $cheminDepart, $action, $nomSrvDestin, $cheminDestin);
	//// ブックマーク。
	moveFav($nomSrvDepart, $cheminDepart, $action, $nomSrvDestin, $cheminDestin);
	if(is_dir(($cheminMiniComDepart = dossierMiniCom($nomSrvDepart, $cheminDepart."/_param"))))
	{
		if(USE_wssite)
		{ //// データディレクトリのリネームと削除。wssiteは自動的にはなされないので。
			if($action == 'rename')
			{
				$cheminMiniComDestin = dossierMiniCom($nomSrvDestin, $cheminDestin."/_param");
				rename($cheminMiniComDepart, $cheminMiniComDestin);
			}
			elseif($action != 'copy')
			{
				removeScandir("wssite", $cheminMiniComDepart, FALSE);
			}
		}
		//// ウィンドウタイトル(wsGlobal)。
		moveWsGlobal($nomSrvDepart, $cheminDepart, $action, $nomSrvDestin, $cheminDestin);
	}
}

function moveMini($nomSrvDepart, $cheminDepart, $action='', $nomSrvDestin='', $cheminDestin='')
{
	if(!moveCheck($nomSrvDepart, $cheminDepart, $action, $nomSrvDestin, $cheminDestin)){ return; }

	$cheminDepartMini = cheminMini($nomSrvDepart, $cheminDepart);
	if($action != 'delete')
	{ $cheminDestinMini = cheminMini($nomSrvDestin, $cheminDestin); }

	if(F_is_file((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartMini)) //// あれば。
	{
		if($action == 'rename')
		{ F_rename((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartMini, $cheminDestinMini); }
		else
		{
			if($action != 'delete')
			{ F_copy((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartMini, (USE_wssite?"wssite":$nomSrvDestin), $cheminDestinMini); }
			if($action != 'copy')
			{ F_unlink((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartMini); }
		}
	}
}

//// コメントのの移動、コピー、名前の変更、削除。
function moveCom($nomSrvDepart, $cheminDepart, $action='', $nomSrvDestin='', $cheminDestin='')
{
	if(!moveCheck($nomSrvDepart, $cheminDepart, $action, $nomSrvDestin, $cheminDestin)){ return; }

	$cheminDepartCom  = cheminCom($nomSrvDepart, $cheminDepart);
	if($action != 'delete')
	{ $cheminDestinCom  = cheminCom($nomSrvDestin, $cheminDestin); }

	if(F_is_file((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartCom) && $comDepart = F_get_contents((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartCom)) //// あれば。
	{
		$filenameDepart = filename($cheminDepart);
		$filenameDestin = filename($cheminDestin);
		if($action == 'rename')
		{
			$comDestin = preg_replace("@(\[[^/]*/)$filenameDepart(\]\n*[^\[]*)@u", "\\1$filenameDestin\\2", $comDepart);
			F_put_contents((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartCom, $comDestin);
		}
		else
		{
			if($nomSrvDepart == $_SESSION["ws"]["nomCorbeille"]) //// ごみ箱から出るとき。消す。
			{ $comDepart = preg_replace("@\[Origin/$filenameDepart\]\n*[^\[]*@u", "", $comDepart); }
			if($action != 'delete')
			{
				//// (必要なら名前を変えた)データを移動先に追加。
				if(preg_match_all("@(\[[^/]*/$filenameDepart\]\n*[^\[]*)@u", $comDepart, $match))
				{
					$matchedCom = implode("", $match[1]);
					$addComDestin = preg_replace("@/$filenameDepart]@u", "/$filenameDestin]", $matchedCom);
					if(F_is_file((USE_wssite?"wssite":$nomSrvDestin), $cheminDestinCom) && ($comDestin = F_get_contents((USE_wssite?"wssite":$nomSrvDestin), $cheminDestinCom)))
					{ $comDestin .= $addComDestin; }
					else
					{ $comDestin = $addComDestin; }
					F_put_contents((USE_wssite?"wssite":$nomSrvDestin), $cheminDestinCom, $comDestin);
				}
			}
			if($action != 'copy')
			{ //// もとにあったファイルの該当するデータは消す。
				$newComDepart = preg_replace("@\[[^/]*/$filenameDepart\]\n*[^\[]*@u", "", $comDepart);
				F_put_contents((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartCom, $newComDepart);
			}
		}
	}
}

//// ウィンドウタイトル(wsGlobal)の移動、コピー、名前の変更、削除。
function moveWsGlobal($nomSrvDepart, $cheminDepart, $action='', $nomSrvDestin='', $cheminDestin='')
{
	if(!moveCheck($nomSrvDepart, $cheminDepart, $action, $nomSrvDestin, $cheminDestin)){ return; }

	if($action != 'rename' && F_is_dir((USE_wssite?"wssite":$nomSrvDepart), dossierMiniCom($nomSrvDepart, $cheminDepart."/_param"))) //// ディレクトリの場合はさらに中のwsGlobalの処理。フォルダのリネームの場合はフォルダの方の名前を変えるので不要。
	{
		$cheminDepartInCom = cheminCom($nomSrvDepart, $cheminDepart."/_param");
		$cheminDestinInCom = cheminCom($nomSrvDestin, $cheminDestin."/_param");
		if(F_is_file((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartInCom) && $inComDepart = F_get_contents((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartInCom))
		{
			if($action != 'delete')
			{
				//// データを移動先に追加。
				if(preg_match("@(\[[^/]*/wsGlobal\]\n*[^\[]*)@u", $inComDepart, $match))
				{
					$addInComDestin = $match[1];
					if(F_is_file((USE_wssite?"wssite":$nomSrvDestin), $cheminDestinInCom) && ($inComDestin = F_get_contents((USE_wssite?"wssite":$nomSrvDestin), $cheminDestinInCom)))
					{ $inComDestin .= $addInComDestin; }
					else
					{ $inComDestin = $addInComDestin; }
					F_put_contents((USE_wssite?"wssite":$nomSrvDestin), $cheminDestinInCom, $inComDestin);
				}
			}
			if($action != 'copy')
			{
				$newInComDepart = preg_replace("@\[[^/]*/wsGlobal\]\n*[^\[]*@u", "", $inComDepart);
				F_put_contents((USE_wssite?"wssite":$nomSrvDepart), $cheminDepartInCom, $newInComDepart);
			}
		}
	}
}

//// ブックマーク(お薦め)の移動、コピー、名前の変更、削除。
function moveFav($nomSrvDepart, $cheminDepart, $action='', $nomSrvDestin='', $cheminDestin='')
{
	global $l_sql; // Need already opened.

	if(!moveCheck($nomSrvDepart, $cheminDepart, $action, $nomSrvDestin, $cheminDestin)){ return; }

	$depart = blindeChemin(preg_replace("@".$_SESSION["ws"]["$nomSrvDepart"]["rootServeur"]."@u", "/", $cheminDepart));
	$oldPath = blindeChemin(dirname($depart)); //// dirname()をしたらblindeChemin()をしておく。"./"のことあり。
	$oldFile = filename($depart);
	if($action != 'delete')
	{
		$destin = blindeChemin(preg_replace("@".$_SESSION["ws"]["$nomSrvDestin"]["rootServeur"]."@u", "/", $cheminDestin));
		$newPath = blindeChemin(dirname($destin));
		$newFile = filename($destin);
	}

	if(empty($l_sql) || !$l_sql->test()) //// この関数を呼ぶプロセスでopenしているはずだがねんのため。
	{
		$l_sql = new class_sql();
		$l_sql->connect();
	}
	if($l_sql->test())
	{
		//// このサーバーのこのディレクトリに関するデータをすべて抽出。
		$selectRequest = "SELECT * FROM wsfiles WHERE nomServeur = '".$l_sql->sql_escape_string($nomSrvDepart)."' AND ( path = '".$l_sql->sql_escape_string($oldPath)."' OR path LIKE '".$l_sql->sql_escape_string(blindeChemin("$oldPath/"))."%' ) ";
		$selectResults = $l_sql->request_result($selectRequest);
		if(!empty($selectResults))
		{
			foreach($selectResults as $selectData)
			{
				$selectPath = $selectData['path'];
				$selectFile = $selectData['file'];
				if(preg_match("@^".blindeChemin("$oldPath/$oldFile")."(/|$)@u", $selectPath)) //// ディレクトリの場合は先に中身の処理をしておく。
				{
					if($action == 'delete')
					{
						$request = "DELETE FROM wsfiles WHERE nomServeur = '".$nomSrvDepart."' AND path = '".$selectPath."' AND file = '".$selectFile."' ";
						$l_sql->request($request);
					}
					elseif($action == 'rename')
					{
						$changedPath = preg_replace("@^".blindeChemin("$oldPath/$oldFile")."(/|$)@u", blindeChemin("$newPath/$newFile").'\1', $selectPath);
						$request = "UPDATE wsfiles SET nomServeur = '".$l_sql->sql_escape_string($nomSrvDestin)."', path = '".$l_sql->sql_escape_string($changedPath)."' WHERE nomServeur = '".$nomSrvDepart."' AND path = '".$selectPath."' AND file = '".$selectFile."' ";
						$l_sql->request($request);
					}
				}
				elseif($oldPath == $selectPath && $oldFile == $selectFile)
				{
					if($action == 'delete')
					{
						$request = "DELETE FROM wsfiles WHERE nomServeur = '".$nomSrvDepart."' AND path = '".$oldPath."' AND file = '".$oldFile."' ";
						$l_sql->request($request);
					}
					elseif($action == 'copy')
					{
						$request = "INSERT INTO wsfiles (idUser, idServeur, nomServeur, username, path, file, commentaires, version, viewed, favoris) VALUES ( ".$_SESSION["ws"]["idUser"].", ".$_SESSION["ws"]["$nomSrvDestin"]["idServeur"].", '".$l_sql->sql_escape_string($nomSrvDestin)."', '".$l_sql->sql_escape_string($_SESSION["ws"]["nomUser"])."', '".$l_sql->sql_escape_string($newPath)."', '".$l_sql->sql_escape_string($newFile)."', '', '', 0, 1) ";
						$l_sql->request($request);
					}
					else
					{
						$request = "UPDATE wsfiles SET nomServeur = '".$l_sql->sql_escape_string($nomSrvDestin)."', path = '".$l_sql->sql_escape_string($newPath)."', file = '".$l_sql->sql_escape_string($newFile)."' WHERE nomServeur = '".$nomSrvDepart."' AND path = '".$oldPath."' AND file = '".$oldFile."' ";
						$l_sql->request($request);
					}
				}
			}
		}
////		$l_sql->disconnect(); //// ここでdisconnectすると呼出元のプロセスがこける。
	}
}
?>
