<?php
/************************************************************************/
/*                                WEBSHARE                              */
/************************************************************************/
//
// Copyright (c) 2009 by Virginie Vivancos
// http://www.webshare.fr
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License.
//
// =======================================================================
// Fonction : Ouvre un fichier selon son type
// Nom      : ouvrir.php
// Version  : 0.8.2
// Date     : 24/04/09
// =======================================================================
// WebShare0.8.2ακ1.7 : 2012 Tanabata version.
// Reformed by kiyoshi@kuragane.jp / 2012.02.09(κ1.0) - 2012.07.07(κ1.7)
// =======================================================================

//// サーバーのコンテンツを送信する。

session_start();
include_once "auth.php";
include_once "../wspasswd/define.php";
include_once "fonctions.php";

verifie($_REQUEST["url"]);

$l_sql = new class_sql();
$l_sql->connect();

$nomSrv    = $_SESSION["ws"]["serveurActif"];
if(isset($_REQUEST["srv"])) { $nomSrv = $_REQUEST["srv"]; }
$chemin    = convertUTF8($_SESSION["ws"]["cheminActif"]);
$cheminRep = $_SESSION["ws"]["rootWeb"].blindeChemin("/".$_SESSION["ws"]["dossierActif"]."/");
$url       = stripslashes($_REQUEST["url"]);
$rep       = blindeChemin("$chemin/$url");
$fichier   = filename($rep);
$typeSrv   = $_SESSION["ws"]["$nomSrv"]["typeServeur"];

if($typeSrv == 2)
{
	$_SESSION["ws"]["$nomSrv"]["connexion"]=connexionFTP($nomSrv);
}

if(strstr($url, "http") === false)
{
	$distant = 0; //// ローカルもしくはFTP
	$extension = strtolower(substr($url, intval(strrpos($url, "."))+1));
}
else
{
	$distant = 1;
	preg_match("@^([[:alpha:]]*)\:\/\/([[:alnum:]-\.]*)[\/]?([[:alnum:]-\/]*)\.([[:alnum:]]*)[\?]?([[:alnum:]=&]*).*$@", "$url", $reglien);
	$extension = strtolower(trim($reglien[4]));
	$site = $cheminRep;
}

if(isset($_REQUEST["pop"]) && ($_REQUEST["pop"] == "1")){ $pop = 1; } //// PC側で開く指定らしい。
else{ $pop = 0; }
if(isset($_REQUEST["nothl"]) && ($_REQUEST["nothl"] == "1")){ $nothl = 1; } //// plug-in windowで開くため？xsl成形をしない指定らしい。
else{ $nothl = 0; }
if((isset($_REQUEST["forcedl"]) && $_REQUEST["forcedl"] == 1)){ $forcedl = 1; } //// 強制ダウンロード用フラグらしい。$popも1にされる。
else{ $forcedl = 0; }
$typeMime = $_SESSION["ws"]["assoc"]["$extension"]["extmime"];

// Force le téléchargement si requis
if($typeMime == "image/jpeg")
{
	header("Content-Type: ".$typeMime);
}
else
{
	if($forcedl || ($typeMime == ""))
	{
		header("Content-type: application/force-download");
		$pop = 1;
	}
	elseif(($typeMime != "text/plain") && ($typeMime != "text/html") && ($typeMime != "application/x-font-TrueType"))
	{
		header("Content-Type: ".$typeMime);
	}
}

header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: pre-check=0, post-check=0, max-age=0');
header('Pragma: anytextexeptno-cache', true);
header('Cache-control: private');
header('Expires: 0');

// Ouvre le fichier en popup si requis
$nomfichier = urlToUtf8($fichier); //// ダウンロード時やアクセス時の名前を決めている。LinuxはOK。Windowsだと日本語は文字化けする。
if(isset($_SERVER['HTTP_USER_AGENT']) && preg_match('@Windows @', $_SERVER['HTTP_USER_AGENT']))
{ $nomfichier = rawurlencode($nomfichier); } //// WindowsはOK, Linuxは%表記になる。
if($pop || $forcedl)
{ header("content-disposition: attachment; filename=\"$nomfichier\""); }
else
{ header("content-disposition: filename=\"$nomfichier\""); }

////flush();//// ここでやってしまうと動画が再生されない。

if($typeMime == "text/xml") // Lecture d'un Flux RSS
{
	if($distant){ $content = @file_get_contents($url); }
	else{ $content = F_get_contents($nomSrv, $rep); }

	if(!$nothl)
	{
		if(preg_match("@(<.*xml-stylesheet.*>)@i", $content)) //// , $content追加。書き忘れ？
		{
			$content = preg_replace("@(<\/*rss.*>)@i", "", preg_replace("@(<.*xml-stylesheet.*>)@i", '<'.'?xml-stylesheet type="text/xsl" href="xsl/rss.xsl.php" ?'.'>', $content));
		}
    else
		{
			$content = preg_replace("@(<\/*rss.*>)@i", "", preg_replace("@(<channel>)@i", '<'.'?xml-stylesheet type="text/xsl" href="xsl/rss.xsl.php" ?'.'><channel>', $content));
		}
	}
	$content = preg_replace("@(:encoded)@i", "", $content);
	if($distant){ echo $content."\n"; }
	else{ echo convertUTF8($content)."\n"; }
}
elseif(($typeMime == "text/plain") || ($typeMime == "text/css") || (!strrpos($fichier, "."))) // Lecture d'un fichier texte
{ //// テキストファイルプレビュー
	header("Content-Type: text/html; Charset=UTF-8");
	if($distant){ $content = @file_get_contents($url); }
	else{ $content = F_get_contents($nomSrv, $rep); }

	if(($extension == "php") && !$nothl && !$distant && !$forcedl && !$pop){ $content = ColorPhpCode($content); }
	if($distant || ($typeSrv == 2))
	{
		$content = preg_replace('@src="([^h][^t][^t][^p].*)"@',  'src="'.$site.'\\1"',  $content);
		$content = preg_replace("@src='([^h][^t][^t][^p].*)'@",  "src='".$site."\\1'",  $content);
		$content = preg_replace('@href="([^h][^t][^t][^p].*)"@', 'href="'.$site.'\\1"', $content);
		$content = preg_replace("@href='([^h][^t][^t][^p].*)'@", "href='".$site."\\1'", $content);
		$content = preg_replace("@url\(([^h][^t][^t][^p].*)\)@", "url(".$site."\\1)",   $content);
	}

	//// テキストファイルプレビューウインドウ作成
	if(!$nothl && !$distant && !$forcedl && !$pop)
	{
		$content = nl2br(preg_replace('@(<[^>]+>)\n@um', '\1', convertUTF8($content))); //// nl2br,preg_replace追加
		echo
"<html>
  <head>
    <script type='text/javascript'>
      function r(){".(($navig=="IE7")?'document.getElementById("editor").style.height= eval((!document.body.clientHeight?document.documentElement.clientHeight:document.body.clientHeight)-50)+"px";':';')."}
    </script>
    <style>
      .cl{text-align:right;background:#888;color:#000;font-size:13px}\n .cd {font-size:13px}
    </style>
  </head>
  <body style='margin:0;border:0;padding:0px 6px 0px 0px;background:gray;overflow:hidden;font-size:13px' onload='r()' onresize='r()'>
    <div id='editor' style='width:100%;height:100%;padding:0px 4px;background:#fff;color:#000;overflow:auto;font-family:Courier New;white-space:normal;'>$content</div>
  </body>
</html>
"; //// IE8は-50pxはいらない。7はどうかな？
	}
	else
	{
		echo convertUTF8($content);
	}
}
elseif($typeMime == "text/html") // Lecture d'une page html
{
	header("Content-Type: text/html; Charset=UTF-8");
	if($distant)
	{ $content = @file_get_contents($url); }
	else
	{ $content = F_get_contents($nomSrv, $rep); }
	if(!$nothl && !$distant)
	{
		$content = preg_replace('@src="([^h][^t][^t][^p].*)"@',        'src="'.$cheminRep.'\\1"',  $content);
		$content = preg_replace("@src='([^h][^t][^t][^p].*)'@",        "src='".$cheminRep."\\1'",  $content);
		$content = preg_replace('@href="([^h][^t][^t][^p].*)"@',       'href="'.$cheminRep.'\\1"', $content);
		$content = preg_replace("@href='([^h][^t][^t][^p].*)'@",       "href='".$cheminRep."\\1'", $content);
		$content = preg_replace("@url\(([^h][^t][^t][^p].*)\)@",       "url(".$cheminRep."\\1)",   $content);
		$content = preg_replace('@background="([^h][^t][^t][^p].*)"@', 'background="'.$cheminRep.'\\1"', $content);
	}
	if($distant)
	{
		$content = preg_replace('@src="([^h][^t][^t][^p].*)"@',  'src="'.$site.'\\1"',  $content);
		$content = preg_replace("@src='([^h][^t][^t][^p].*)'@",  "src='".$site."\\1'",  $content);
		$content = preg_replace('@href="([^h][^t][^t][^p].*)"@', 'href="'.$site.'\\1"', $content);
		$content = preg_replace("@href='([^h][^t][^t][^p].*)'@", "href='".$site."\\1'", $content);
		$content = preg_replace("@url\(([^h][^t][^t][^p].*)\)@", "url(".$site."\\1)",   $content);
	}
	echo convertUTF8($content);
}
elseif($typeMime == "application/x-font-TrueType") // Lecture d'une page html
{
	$pangramme = "";
	if(!empty($_REQUEST["pangramme"])){ $pangramme = rawurldecode($_REQUEST["pangramme"]); }
	echo
 "<div style='font-family:arial;'>Text : <input type='text' value='' id='pangramme' style='width:85%'>"
."<input type='button' value='View' onclick='window.location.href=\"".$_SERVER["REQUEST_URI"]."&pangramme=\"+encodeURIComponent(document.getElementById(\"pangramme\").value)'></div>"
."<img src='apercufonte.php?url=".rawurlencode($rep)."&pangramme=".rawurlencode($pangramme)."'>";
}
elseif($distant) // Lecture d'un fichier distant
{
	@readfile($url);
}
else
{
	header("Content-Length: ".F_filesize($nomSrv, $rep)); //// これがないと動画再生等はうまくいかない。テキストの場合はあると途中で切れる。
	header("Accept-Ranges: none"); // 中断再開、部分ダウンロード対応はしない。するならコードを書いてbytes。
////	echo F_get_contents($nomSrv, $rep);
	F_readfile($nomSrv, $rep);
}

if($typeSrv == 2){ closeFTP($nomSrv); }

$tabLog = array("3", "1", $_SESSION["ws"]["dia"]["savingFile"]." ".$fichier,$_SESSION["ws"]["nomUser"], $_SESSION["ws"]["dossierActif"], $fichier, "");
$l_sql->logAction($tabLog);
$l_sql->disconnect();

?>
