<?php
/************************************************************************/
/*                                WEBSHARE                              */
/************************************************************************/
//
// Copyright (c) 2012 by Kiyoshi Kuragane
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License.
//
// =======================================================================
// Fonction : Restore items from corbeille
// Nom      : restaurer.php
// Version  : 0.8.2ακ1.7
// Date     : 07/07/12
// =======================================================================
// WebShare0.8.2ακ1.7 : 2012 Tanabata version.
// Written by kiyoshi@kuragane.jp / 2012.02.09(κ1.0) - 2012.07.07(κ1.7)
// =======================================================================

//// ファイルやディレクトリをごみ箱から元に戻す。
//// 元はコピー、ペースト方式だったが簡単に元に戻せるようにした。

header ("Content-type: text/html; charset=utf-8");

session_start();
include_once "auth.php";
include_once "../wspasswd/define.php";
include_once "fonctions.php";

$l_sql = new class_sql();
$l_sql->connect();

$Message = "";

// L'utilisateur doit être autorisé à effectuer l'opération
if($_SESSION["ws"]["auth4"] == "on") //// 移動の権限がある。
{
	// Récupération des paramètres
	// Formatage des chemins de départ et d'arrivée
	$lienElement = stripslashes(preg_replace("@^/+|/+$@", "", rawurldecode($_REQUEST["nomLien"])));
	$topElement  = preg_replace("@^([^/]*).*$@", '\1', $lienElement);
	$nomElement  = filename($lienElement);
	$_SESSION["ws"]["progress"] = $nomElement;
	$typeFichier = trim($_REQUEST["nomPro"]);
	$nomSrvDepart  = $_SESSION["ws"]["nomCorbeille"];
	$destParamFile = blindeChemin($_SESSION["ws"]["repCorbeille"]."/.param");

	if(($destParam = file_get_contents($destParamFile)) === false)
	{
		echo "Origin Data is missing. Restore is FAILED.";
		exit;
	}
	if(preg_match("@\[[^/]*/$topElement\]\n*([^/]+)/([^\n\[]*)\n*@u", $destParam, $match))
	{
		$nomSrvDestin = $match[1]; //// 元のサーバー名
		$dirDestin    = $match[2]; //// 元のディレクトリ
		if($lienElement == $topElement)
		{
			$destParam = preg_replace("@\[[^/]*/$topElement\]\n*([^/]+)/([^\n\[]*)\n*@u", "", $destParam); //// 移動するデータは消しておく。まだ書き込まないけど。
		}
	}
	else
	{
		echo "Origin data is missing. Restore is failed.";
		exit;
	}
	$typeSrvDestin = $_SESSION["ws"]["$nomSrvDestin"]["typeServeur"];

	$cheminDepart = blindeChemin($_SESSION["ws"]["repCorbeille"]."/$lienElement");
	$cheminDestin = blindeChemin($_SESSION["ws"]["$nomSrvDestin"]["rootServeur"]."/$dirDestin/$lienElement");

	// Teste si la variable de copie/déplacement n'est pas vide
	//// 拒絶事項か否かチェック。
	// Vérifie l'absence d'expressions interdites dans le nom
	if(preg_match($_SESSION["ws"]["varsUser"], $cheminDestin))
	{
		echo $_SESSION["ws"]["dia"]["noPermission"];
		$tabLog = array("28", "-1", $_SESSION["ws"]["dia"]["noPermission"], $_SESSION["ws"]["nomUser"], dirname($cheminDestin), filename($cheminDestin), "restaurer");
		$l_sql->logAction($tabLog);
		exit;
	}

	// L'utilisateur ne peut pas effectuer d'opération au dessus de sa racine virtuelle
	verifie($cheminDepart); //// ちゃんとセットされているかなどチェック。
	verifie($cheminDestin); //// ちゃんとセットされているかなどチェック。

	// Connexion au serveur FTP
	if($typeSrvDestin == 2){ $_SESSION["ws"]["$nomSrvDestin"]["connexion"] = connexionFTP($nomSrvDestin); }

	// L'élément est un fichier
	if($typeFichier != "dossier") //// フォルダ以外。
	{
		//// ファイルの場合は上書きしないよう名前を変える。フォルダはその中に書き込むのでいい。
		// Si les chemins de départ et d'arrivée sont identiques, on crée une simple copie de l'élément
		if($typeSrvDestin == 1)
		{
			$prefixNum = 1;
			$dossierDestin = dirname($cheminDestin);
			while(F_is_dir($nomSrvDestin, $cheminDestin) || F_is_file($nomSrvDestin, $cheminDestin))
			{
				++$prefixNum;
				$cheminDestin = blindeChemin($dossierDestin."/$prefixNum-$nomElement");
			}
		}
		// Copie du fichier
		if(F_copy($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin) === false)
		{
			$Message = $_SESSION["ws"]["dia"]["theFile"]." '".$nomElement."' ".$_SESSION["ws"]["dia"]["hasNotBeen"]." ".$_SESSION["ws"]["dia"]["moved"]." ".$erreur;
		}
		else
		{
			// ou déplacement du fichier
			moveMiniComFav($nomSrvDepart, $cheminDepart, 'copy', $nomSrvDestin, $cheminDestin);
			if(F_unlink($nomSrvDepart, $cheminDepart) === false)
			{
				$Message = $_SESSION["ws"]["dia"]["theFile"]." '".$nomElement."' ".$_SESSION["ws"]["dia"]["hasNotBeen"]." ".$_SESSION["ws"]["dia"]["moved"].", ".$_SESSION["ws"]["dia"]["onlyCopy"];
			}
			else
			{
				moveMiniComFav($nomSrvDepart, $cheminDepart, 'delete');
				$Message = $_SESSION["ws"]["dia"]["theFile"]." '".$nomElement."' ".$_SESSION["ws"]["dia"]["hasBeen"]." ".$_SESSION["ws"]["dia"]["moved"]." ".$_SESSION["ws"]["dia"]["withSuccess"].".";
			}
		}
	}
	else //// フォルダの復元
	{
		// Copie d'un dossier
		if(F_copieScandir($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin) === false)
		{
			$Message = $_SESSION["ws"]["dia"]["theDir"]." '".$nomElement."' ".$_SESSION["ws"]["dia"]["hasNotBeen"]." ".$_SESSION["ws"]["dia"]["moved"]." ".$erreur;
		}
		else
		{
			// ou déplacement d'un dossier
			if(F_removeScandir($nomSrvDepart, $cheminDepart) === false)
			{
				$Message = $_SESSION["ws"]["dia"]["theDir"]." '".$nomElement."' ".$_SESSION["ws"]["dia"]["hasNotBeen"]." ".$_SESSION["ws"]["dia"]["moved"].", ".$_SESSION["ws"]["dia"]["onlyCopy"];
			}
			else
			{
					$Message = $_SESSION["ws"]["dia"]["theDir"]." '".$nomElement."' ".$_SESSION["ws"]["dia"]["hasBeen"]." ".$_SESSION["ws"]["dia"]["moved"]." ".$_SESSION["ws"]["dia"]["withSuccess"].".";
			}
		}
	}
	if($typeSrvDestin == 2){ closeFTP($nomSrvDestin); }
	if(!is_dir($cheminDepart) && !is_file($cheminDepart)) //// 完了して消去された。
	{
		file_put_contents($destParamFile, $destParam);
	} //// 元パスパラメータを削除したのを書込。
}
else //// 権限なし。
{
	$Message = $_SESSION["ws"]["dia"]["prohibited"];
}

echo $Message;
$_SESSION["ws"]["progress"] = "";
$tabLog = array("28", "1", $Message, $_SESSION["ws"]["nomUser"], $_SESSION["ws"]["dossierActif"], $nomElement, "");
$l_sql->logAction($tabLog);
$l_sql->disconnect();

?>
