<?php
/************************************************************************/
/*                                WEBSHARE                              */
/************************************************************************/
//
// Copyright (c) 2009 by Virginie Vivancos
// http://www.webshare.fr
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License.
//
// =======================================================================
// Fonction : Supprimer un dossier ou un fichier
// Nom      : supprimer.php
// Version  : 0.8.2
// Date     : 24/04/09
// =======================================================================
// WebShare0.8.2ακ1.7 : 2012 Tanabata version.
// Reformed by kiyoshi@kuragane.jp / 2012.02.09(κ1.0) - 2012.07.07(κ1.7)
// =======================================================================

//// ファイルやフォルダの削除を実行する。
//// ごみ箱を有効にするようコード追加。

header ("Content-type: text/html; charset=utf-8");

session_start();
include_once "auth.php";
include_once "../wspasswd/define.php";
include_once "fonctions.php";

$l_sql = new class_sql();
$l_sql->connect();

// Récupération des informations serveurs
if(!empty($_REQUEST["nomSrv"])){ $nomSrvDepart = $_REQUEST["nomSrv"]; }
else{ $nomSrvDepart = $_SESSION["ws"]["serveurActif"]; }
$typeSrvDepart = $_SESSION["ws"]["$nomSrvDepart"]["typeServeur"];
$nomPro = $_REQUEST["nomPro"];
$chemin = blindeChemin($_SESSION["ws"]["$nomSrvDepart"]["rootServeur"]."/".$_SESSION["ws"]["$nomSrvDepart"]["repServeur"]."/");

//// ごみ箱から指定のファイル等の削除。
if($_REQUEST["nomSrv"] == $_SESSION["ws"]["nomCorbeille"])
{
	$typeSrvDepart = 1; //// ここは1。単なるサーバーフォルダとみなす。3の場合はごみ箱がすべて削除されてしまう。
	if($_REQUEST["supdef"] != 1){ exit; }
	if(empty($_SESSION["ws"]["repCorbeille"])){ exit; }
	$chemin = $_SESSION["ws"]["repCorbeille"];
}

//// ごみ箱を空にする。
if($_REQUEST["emptybin"] == 1)
{
	$typeSrvDepart = 3; //// ごみ箱そのものを空にするコードをセット。
	if(empty($_SESSION["ws"]["repCorbeille"])){ exit; }
}

$nomSrvDestin  = $_SESSION["ws"]["nomCorbeille"];
$typeSrvDestin = $_SESSION["ws"]["$nomSrvDestin"]["typeServeur"];

// L'utilisateur ne peut pas effectuer d'opération au dessus de sa racine virtuelle
if($_REQUEST["emptybin"] != 1){ verifie($_REQUEST["nomLien"]); }

// L'utilisateur doit être autorisé à effectuer l'opération
if($_SESSION["ws"]["auth5"] == "on")
{
	// Le nom doit être rempli obligatoirement
	if(!empty($_REQUEST["nomLien"]))
	{
		// Construction des chemins
		$nomLien    = stripslashes(rawurldecode(trim($_REQUEST["nomLien"])));
		$nomElement = urlToUtf8(filename($nomLien)); //// メッセージ以外には使っていない。
		$cheminElement   = stripslashes(blindeChemin(convertUTF8("$chemin/$nomLien")));
		$cheminCorbeille = blindeChemin($_SESSION["ws"]["repCorbeille"].filename($nomLien));
		$_SESSION["ws"]["progress"] = $nomElement;

		// Test du contenu des variables
		if(preg_match($_SESSION["ws"]["varsUser"], $nomLien))
		{
			echo $_SESSION["ws"]["dia"]["noPermission"];
			$tabLog = array("13", "-1", $_SESSION["ws"]["dia"]["noPermission"], $_SESSION["ws"]["nomUser"], $cheminElement, $nomElement, "");
			$l_sql->logAction($tabLog);
			$l_sql->disconnect();
			exit;
		}

		// Si les chemins de départ et d'arrivée sont identiques, on crée une simple copie de l'élément
		$prefixNum = 1;
		while(is_dir($cheminCorbeille) || is_file($cheminCorbeille))
		{
			++$prefixNum;
			$cheminCorbeille = blindeChemin($_SESSION["ws"]["repCorbeille"]."/$prefixNum-".filename($nomLien));
		}

		// Renommage du ou des éléments
		if($typeSrvDepart == 2){ $_SESSION["ws"]["$nomSrvDepart"]["connexion"] = connexionFTP($nomSrvDepart); }
		if($typeSrvDepart != 3)
		{
			// En local
			if($nomPro == "dossier") //// ディレクトリの削除
			{
				if($_SESSION["ws"]["$nomSrvDepart"]["binServeur"]) //// このサーバーのごみ箱が有効なら、
				{
					F_copyDirToCorbeille($nomSrvDepart, $cheminElement, $nomSrvDestin, $cheminCorbeille); //// ごみ箱にコピー。
				}
				if(F_removeScandir($nomSrvDepart, $cheminElement) === false)
				{
					$message= $_SESSION["ws"]["dia"]["theRemove"]." ".$_SESSION["ws"]["dia"]["ofDir"]." '".$nomElement."' ".$_SESSION["ws"]["dia"]["hasFailed"].". ".$erreur;
				}
				else
				{
					if($chemin == $_SESSION["ws"]["repCorbeille"]) //// ごみ箱からの削除なら、
					{
						deleteBinParam($nomLien); //// 復元パスは消去。
					}
					$message= $_SESSION["ws"]["dia"]["theDir"]." '".$nomElement."' ".$_SESSION["ws"]["dia"]["hasBeen"]."  ".$_SESSION["ws"]["dia"]["deleted"]." ".$_SESSION["ws"]["dia"]["withSuccess"];
				}
			}
			else //// ファイルの削除
			{
				if($_SESSION["ws"]["$nomSrvDepart"]["binServeur"]) //// このサーバーのごみ箱が有効なら、
				{
					F_copyFileToCorbeille($nomSrvDepart, $cheminElement, $nomSrvDestin, $cheminCorbeille); //// ごみ箱にコピー。
				}
				if(F_unlink($nomSrvDepart, $cheminElement) === false)
				{
					$message= $_SESSION["ws"]["dia"]["theRemove"]." ".$_SESSION["ws"]["dia"]["ofFile"]." '".$nomElement."' ".$_SESSION["ws"]["dia"]["hasFailed"].". ".$erreur;
				}
				else
				{
					if($chemin == $_SESSION["ws"]["repCorbeille"]) //// ごみ箱からの削除なら、
					{
						deleteBinParam($nomLien); //// 復元パスは消去。
					}
					moveMiniComFAV($nomSrvDepart, $cheminElement, 'delete');
					$message= $_SESSION["ws"]["dia"]["theFile"]." '".$nomElement."' ".$_SESSION["ws"]["dia"]["hasBeen"]."  ".$_SESSION["ws"]["dia"]["deleted"]." ".$_SESSION["ws"]["dia"]["withSuccess"];
				}
			}
		}
	}
	if($typeSrvDepart == 3) //// ごみ箱そのものを空にする。
	{
		// Vidage de la corbeille
		$nomSrvDepart  = $_SESSION["ws"]["nomCorbeille"];
		$cheminElement = $_SESSION["ws"]["repCorbeille"];
		if(removeScandir($nomSrvDepart, $cheminElement) !== false) //// ゴミ箱をそっくり削除して、
		{
			moveMiniComFAV($nomSrvDepart, $cheminElement, 'delete');
			mkdir($_SESSION["ws"]["repCorbeille"]); //// あたらしいごみ箱をつくる。
			chmod($_SESSION["ws"]["repCorbeille"], NEWDIR_PERM);
			$message = $_SESSION["ws"]["dia"]["emptyBinResult"];
		}
		else
		{
			$message = $_SESSION["ws"]["dia"]["identProblem2"];
		}
  }
	if($typeSrvDepart == 2){ closeFTP($nomSrvDepart); }
}
else
{
	$message = $_SESSION["ws"]["dia"]["prohibited"];
}

echo $message;

$tabLog = array("13", "1", $message, $_SESSION["ws"]["nomUser"], $cheminElement, $nomElement, "");
$_SESSION["ws"]["progress"] = "";
$l_sql->logAction($tabLog);
$l_sql->disconnect();

exit;

//// 以下、ごみ箱を有効にするため追加。ただし可能な限りということでエラーは返さない。
function F_copyDirToCorbeille($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin, $saveOrigin=true)
{
	if(F_is_FTPServeur($nomSrvDepart))
	{ copyFTPDirToCorbeille($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin, $saveOrigin); }
	else
	{ copyDirToCorbeille($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin, $saveOrigin); }
}

function F_copyFileToCorbeille($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin, $saveOrigin=true)
{
	if(F_is_FTPServeur($nomSrvDepart))
	{ copyFTPFileToCorbeille($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin, $saveOrigin); }
	else
	{ copyFileToCorbeille($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin, $saveOrigin); }
}

function copyDirToCorbeille($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin, $saveOrigin=true)
{
	if($saveOrigin) //// トップでのみ元のパスを記録。
	{ saveBinParam($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin); }
	ensure_dirpath($cheminDestin);
	if($handle = opendir($cheminDepart))
	{
		while(($file = readdir($handle)) !== false)
		{
			if(preg_match("@^(?:[.]{2}|[.]{1}|wsminis)$@u", $file)){ continue; }
			if(is_dir("$cheminDepart/$file")) //// 中のフォルダ
			{ copyDirToCorbeille($nomSrvDepart, blindeChemin("$cheminDepart/$file"), $nomSrvDestin, blindeChemin("$cheminDestin/$file"), false); }
			else //// 中のファイル
			{ copyFileToCorbeille($nomSrvDepart, blindeChemin("$cheminDepart/$file"), $nomSrvDestin, blindeChemin("$cheminDestin/$file"), false); }
		}
		closedir($handle);
		moveMiniComFav($nomSrvDepart, $cheminDepart, 'copy', $nomSrvDestin, $cheminDestin);
	}
}

function copyFileToCorbeille($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin, $saveOrigin=true)
{
	if($saveOrigin) //// トップでのみ元のパスを記録。
	{ saveBinParam($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin); }
	copy($cheminDepart, $cheminDestin);
	chmod($cheminDestin, NEWFILE_PERM);
	moveMiniComFav($nomSrvDepart, $cheminDepart, 'copy', $nomSrvDestin, $cheminDestin);
}

function copyFTPDirToCorbeille($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin, $saveOrigin=true)
{
	if($saveOrigin) //// トップでのみ元のパスを記録。
	{ saveBinParam($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin); }
	ensure_dirpath($cheminDestin);
	if(($contents = B_ftp_rawlist($nomSrvDepart, blindeChemin($cheminDepart))) !== FALSE)
	{
		foreach($contents as $file)
		{
			if(preg_match("@^(?:[.]{2}|[.]{1}|wsminis)$@u", $file)){ continue; }
			$info  = array();
			$vinfo = preg_split("@[\s]+@u", $file, 9);
			if($vinfo[0] !== "total")
			{
				$fileperms = $vinfo[0];
				$filename  = $vinfo[8];
			}
			if(strpos($fileperms, "d") !== FALSE)
			{ copyFTPDirToCorbeille($nomSrvDepart, blindeChemin("$cheminDepart/$filename"), $nomSrvDestin, blindeChemin("$cheminDestin/$filename"), false); }
			else
			{ copyFTPFileToCorbeille($nomSrvDepart, blindeChemin("$cheminDepart/$filename"), $nomSrvDestin, blindeChemin("$cheminDestin/$filename"), false); }
		}
		moveMiniComFav($nomSrvDepart, $cheminDepart, 'copy', $nomSrvDestin, $cheminDestin);
	}
}

function copyFTPFileToCorbeille($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin, $saveOrigin=true) //// ごみ箱を有効にするため追加。
{
	if($saveOrigin) //// トップでのみ元のパスを記録。
	{ saveBinParam($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin); }
	ftp_get($_SESSION["ws"]["$nomSrvDepart"]["connexion"], $cheminDestin, $cheminDepart, FTP_BINARY);
	chmod($cheminDestin, NEWFILE_PERM);
	moveMiniComFav($nomSrvDepart, $cheminDepart, 'copy', $nomSrvDestin, $cheminDestin);
}

function saveBinParam($nomSrvDepart, $cheminDepart, $nomSrvDestin, $cheminDestin)
{
	$chemin = blindeChemin($_SESSION["ws"]["$nomSrvDepart"]["rootServeur"]."/".$_SESSION["ws"]["$nomSrvDepart"]["repServeur"]."/");
	$cheminElement  = preg_replace("@$chemin@u", "/", $cheminDepart);
	$dossierElement = dirname($cheminElement);
	//// 復元のための元パス(元ディレクトリ)を記録。
	$cheminParam  = blindeChemin($_SESSION["ws"]["repCorbeille"]."/.param"); //// 復元するための元のパスを記録するファイル。
	if($fp = fopen($cheminParam, "a+"))
	{
		$param = "[".$_SESSION["ws"]["nomUser"]."/".filename($cheminDestin)."]\n";
		$param .= blindeChemin("$nomSrvDepart/".$_SESSION["ws"]["$nomSrvDepart"]["repServeur"]."/$dossierElement")."\n";
		fwrite($fp, $param);
		fclose($fp);
		chmod($cheminParam, NEWFILE_PERM);
	}
	//// コメントに元パスを参考として書き込む。
	$cheminBinCom = cheminCom($_SESSION["ws"]["nomCorbeille"], $_SESSION["ws"]["repCorbeille"]."/_param");
	ensure_filepath($cheminBinCom);
	if($fp = fopen($cheminBinCom, "a+")) //// コメントに元パスを記録。
	{
		$param = "[Origin/".filename($cheminDestin)."]\n";
		$param .= blindeChemin("$nomSrvDepart/$cheminElement")."\n";
		fwrite($fp, $param);
		fclose($fp);
		chmod($cheminBinCom, NEWFILE_PERM);
	}
}

function deleteBinParam($nomLien)
{
	$lienElement = stripslashes(preg_replace("@^/+|/+$@", "", $nomLien));
	$topElement  = preg_replace("@^([^/]*).*$@", '\1', $lienElement);
	$destParamFile = blindeChemin($_SESSION["ws"]["repCorbeille"]."/.param");
	if(($destParam = file_get_contents($destParamFile)) !== FALSE)
	{
		if(preg_match("@\[[^/]*/$topElement\]\n*([^/]+)/([^\n\[]*)\n*@u", $destParam, $match))
		{
			$nomSrvDestin = $match[1]; //// 元のサーバー名
			$dirDestin = $match[2]; //// 元のディレクトリ
			if($lienElement == $topElement)
			{
				$destParam = preg_replace("@\[[^/]*/$topElement\]\n*([^/]+)/([^\n\[]*)\n*@u", "", $destParam);
				file_put_contents($destParamFile, $destParam);
			}
		}
	}
}

?>
