<?php
/************************************************************************/
/*                                WEBSHARE                              */
/************************************************************************/
//
// Copyright (c) 2009 by Virginie Vivancos
// http://www.webshare.fr
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License.
//
// =======================================================================
// Fonction : XSL d'affichage des dossiers en mode détails
// Nom      : details.xsl.php
// Version  : 0.8.2
// Date     : 24/04/09
// =======================================================================
// WebShare0.8.2ακ1.7 : 2012 Tanabata version.
// Reformed by kiyoshi@kuragane.jp / 2012.02.09(κ1.0) - 2012.07.07(κ1.7)
// =======================================================================

//// v3 詳細画面の表示。基礎データはnaviguer.phpで作られる。
//// 画面の上の項目タイトル。名前、コメント、... の部分はinterface.phpのinitDetails()で作られる。

session_start();
include_once "../../wspasswd/define.php";
include_once "../fonctions.php";

header('Content-Type: application/xml');
echo '<'.'?xml version="1.0" encoding="UTF-8"'.'?>';

?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" version="4.0" encoding="UTF-8" indent="yes"
		doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN"
		doctype-system="declarations.dtd"/>
	<xsl:template match="/" name="document">
		<xsl:apply-templates/>
	</xsl:template>

	<xsl:template match="repGalerie">
		<xsl:variable name="commentGlobal" select="commentGlobal"/>
		<xsl:if test='(commentGlobal != "")'>
			<div class="headerDetails">
				<xsl:value-of select='commentGlobal'/>
			</div>
		</xsl:if>
		<div id="divFileInfo" style="display:none">
			<xsl:for-each select="ent">
				<xsl:variable name="nom" select="nom"/>
				<xsl:variable name="num" select="num"/>
				<xsl:variable name="lnk" select="lnk"/>
				<xsl:variable name="vis" select="vis"/>
				<xsl:variable name="tai" select="tai"/>
				<xsl:variable name="ext" select="ext"/>
				<xsl:variable name="lab" select="lab"/>
				<xsl:variable name="prm" select="prm"/>
				<xsl:variable name="cmt" select="cmt"/>
				<xsl:variable name="fav" select="fav"/>
				<xsl:variable name="dtm" select="dtm"/>
				<xsl:variable name="pro" select="pro"/>
				<xsl:variable name="web" select="web"/>
				tabFileInfo.fileInfo<xsl:value-of select='num'/>= {
					num : "<xsl:value-of select='num'/>",
					lnk : "<xsl:value-of select='lnk'/>",
					nom : "<xsl:value-of select='nom'/>",
					ext : "<xsl:value-of select='ext'/>",
					lab : "<xsl:value-of select='lab'/>",
					tai : "<xsl:value-of select='tai'/>",
					prm : "<xsl:value-of select='prm'/>",
					pro : "<xsl:value-of select='pro'/>",
					dtm : "<xsl:value-of select='dtm'/>",
					web : "<xsl:value-of select='web'/>",
					fav : "<xsl:value-of select='fav'/>",
					srv : "<xsl:value-of select='srv'/>"
				};
			</xsl:for-each>
		</div>
		<ul class='v3' name="dragLayer" id="dragLayer" style="width:99%;">
			<xsl:for-each select="ent">
				<xsl:variable name="nom" select="nom"/>
				<xsl:variable name="num" select="num"/>
				<xsl:variable name="lnk" select="lnk"/>
				<xsl:variable name="vis" select="vis"/>
				<xsl:variable name="tai" select="tai"/>
				<xsl:variable name="ext" select="ext"/>
				<xsl:variable name="lab" select="lab"/>
				<xsl:variable name="prm" select="prm"/>
				<xsl:variable name="cmt" select="cmt"/>
				<xsl:variable name="fav" select="fav"/>
				<xsl:variable name="lck" select="lck"/>
				<xsl:variable name="dtm" select="dtm"/>
				<xsl:variable name="pro" select="pro"/>
				<xsl:variable name="dbl" select="dbl"/>
				<xsl:variable name="web" select="web"/>
				<xsl:if test='(pro = "sup")'>
					<script language="javascript">boutonUp="<xsl:value-of select='lnk'/>";</script>
				</xsl:if>
				<xsl:variable name="action">
					<xsl:choose>
						<xsl:when test='(prm = "R") or (prm = "RW")'>
							initAction
						</xsl:when>
						<xsl:otherwise>
							rien
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>


<?php //// 詳細リストの行コンテナ ?> 
<li class='cible {$dbl}' onclick='if(altClick==0){$action}(this)' onmouseover='elementOver(this,{$num})' onmouseout='elementOut(this)' style='width:99%;' title="{$nom}<?php echo "\n"; ?>{$cmt}">
	<?php //// 名前の部分 ?> 
	<div class='caseimg'>
		<table style="float:left;padding:0;border:0;margin:0" cellspacing="0"><tr>
			<?php //// imageの後の方にあったコンテキストボタンマークを新しい<td>をつくってずらした。?>
			<td style="text-align:left;vertical-align:middle;width:16px;height:32px">
<?php if(CONTEXT_BUTTON){ ?>
				<span id="accessMc{$num}" style="display:none">
					<img src='<?php echo $_SESSION["ws"]["cheminImg"]?>menuContext.<?php echo $_SESSION["ws"]["formatExt"]?>' onclick="setTimeout('reloadContext()',20)" title="<?php echo $_SESSION["ws"]["dia"]["menuContext"]?>"/>
				</span>
<?php } ?>
			</td>
			<?php //// 縮小画像やアイコン ?> 
			<td style="text-align:center;width:32px;height:32px">
				<u>
					<xsl:if test='(pro != "url")'>
						<xsl:choose>
							<xsl:when test="contains(vis,'http')">
								<img src='{vis}' title="{$nom}" style="max-width:32px;max-height:32px;"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:if test='contains(vis,"moteur/pic") and (ext != "ico")'>
									<img src='<?php echo $_SESSION["ws"]["cheminIcn"]?>{vis}' title="{$nom}<?php echo "\n"; ?>{$cmt}" style="max-width:32px;max-height:32px;"/><?php //// 写真。コメント追加。 ?> 
								</xsl:if>
								<xsl:if test='(ext!="ico") and contains(vis,"moteur/pic")= 0'>
									<img src='<?php echo $_SESSION["ws"]["cheminIcn"]?>minis/{vis}' title="{$nom}<?php echo "\n"; ?>{$cmt}" style="max-width:32px;max-height:32px;"/><?php //// 写真以外。コメント追加。 ?> 
								</xsl:if>
								<xsl:if test='(ext = "ico")'>
									<img src='<?php echo $_SESSION["ws"]["cheminIcn"]?>{vis}' title="{$nom}" style="max-width:32px;max-height:32px;"/>
								</xsl:if>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
					<xsl:if test='(pro = "url")'>
						<xsl:choose>
							<xsl:when test="contains(vis,'http')">
								<img src='{vis}' title="{$nom}" style="max-width:32px;"/>
							</xsl:when>
							<xsl:otherwise>
								<img src='{vis}' title="{$nom}" style="width:32px;"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
				</u>
			</td>
		</tr></table>
	</div>

	<div class='nom'>
		<u>
			<xsl:value-of select="nom"/>
<?php if(LOCKED_ICON >= $_SESSION["ws"]["typeUser"]) { ?>
			<?php //// ロックアイコン。用途と意味不明。 ?> 
			<xsl:if test='(lck = "1")'>
				<img src="<?php echo $_SESSION["ws"]["cheminImg"]?>panneau.<?php echo $_SESSION["ws"]["formatExt"]?>"  title='<?php echo $_SESSION["ws"]["dia"]["fileInUse"]?>' style='margin-right:2px'/>
			</xsl:if>
			<?php //// 鍵アイコン。必ずしも実際のパーミッションとは一致しない。 ?> 
			<xsl:if test='(prm = "R")'>
				<img src='<?php echo $_SESSION["ws"]["cheminImg"]?>verrou1.<?php echo $_SESSION["ws"]["formatExt"]?>' title='<?php echo $_SESSION["ws"]["dia"]["readOnly"]?>'/>
			</xsl:if>
			<xsl:if test='(prm = "W")'>
				<img src='<?php echo $_SESSION["ws"]["cheminImg"]?>verrou2.<?php echo $_SESSION["ws"]["formatExt"]?>' title='<?php echo $_SESSION["ws"]["dia"]["writeOnly"]?>'/>
			</xsl:if>
			<xsl:if test='(prm = "N")'>
				<img src='<?php echo $_SESSION["ws"]["cheminImg"]?>verrou3.<?php echo $_SESSION["ws"]["formatExt"]?>' title='<?php echo $_SESSION["ws"]["dia"]["locked"]?>'/>
			</xsl:if>
<?php } ?>
<?php if(UNLOCKED_ICON >= $_SESSION["ws"]["typeUser"]) { ?>
			<xsl:if test='(prm = "RW") and (pro != "sup")'>
				<img src='<?php echo $_SESSION["ws"]["cheminImg"]?>verrou0.<?php echo $_SESSION["ws"]["formatExt"]?>' title='<?php echo $_SESSION["ws"]["dia"]["readWrite"]?>' />
			</xsl:if>
<?php } ?>
		</u>
		<xsl:if test='(cmt != "")'>
			<img src='<?php echo $_SESSION["ws"]["cheminImg"]?>infocomment.<?php echo $_SESSION["ws"]["formatExt"]?>' title="{$cmt}" onmouseover="altClick=1;" onmouseout="altClick=0;"  onclick="memoContext();commenter(iciLien,'<?php echo $_SESSION["ws"]["dia"]["toComment"]?>');return false;"/>
		</xsl:if>
		<xsl:if test='(pro = "url")'>
			<img src='<?php echo $_SESSION["ws"]["cheminImg"]?>infolien.<?php echo $_SESSION["ws"]["formatExt"]?>' title="{$web}"/>
		</xsl:if>
		<xsl:if test='(fav = "1")'>
			<img src="<?php echo $_SESSION["ws"]["cheminImg"]?>memo.<?php echo $_SESSION["ws"]["formatExt"]?>"  title='<?php echo $_SESSION["ws"]["dia"]["favoris"]?>' />
		</xsl:if>
	</div>

	<?php //// コメントの部分 ?> 
	<div class='apercucmt comment'>
		<xsl:value-of select="substring(cmt, 0, 64)"/>
	</div>

	<?php //// ファイル容量の部分 ?>
	<div class='taille'>
		<xsl:if test="($tai &gt; 0) and ($tai &lt; 1024)">
			<xsl:value-of select="number(tai)"/> <?php echo $_SESSION["ws"]["dia"]["octet"]?>
		</xsl:if>
		<xsl:if test="($tai &gt;= 1024) and ($tai &lt; 1048576)">
			<xsl:value-of select="format-number(number(tai) div number(1024),'#.00')"/> K<?php echo $_SESSION["ws"]["dia"]["octet"]?>
		</xsl:if>
		<xsl:if test="($tai &gt;= 1048576) and ($tai &lt; 1073741824)">
			<xsl:value-of select="format-number(number(tai) div number(1048576),'#.00')"/> M<?php echo $_SESSION["ws"]["dia"]["octet"]?>
		</xsl:if>
		<xsl:if test="($tai &gt;= 1073741824)">
			<xsl:value-of select="format-number(number(tai) div number(1073741824),'#.00')"/> G<?php echo $_SESSION["ws"]["dia"]["octet"]?>
		</xsl:if>
	</div>

	<?php //// ファイルタイプの部分 ?> 
	<div class='extension'>
		<xsl:if test='(pro = "url") and (ext != "url")'>
			<xsl:value-of select="ext"/>
		</xsl:if>
		<xsl:if test='(pro = "url") and (ext = "url")'>
			Url
		</xsl:if>
		<xsl:if test='(pro = "local")'>
			<xsl:value-of select="ext"/>
		</xsl:if>
		<xsl:if test='(pro = "dossier")'>
			<?php echo $_SESSION["ws"]["dia"]["rep"]?>
		</xsl:if>
		<xsl:if test='(pro = "sup")'>
			<?php echo $_SESSION["ws"]["dia"]["niveauSup"]?>
		</xsl:if>
		<div class='labelType'>
			<xsl:value-of select="lab"/>
		</div>
	</div>

	<?php //// 作成日時の部分 ?>
	<div class='datemodif'>
		<xsl:value-of select="dtm"/>
	</div>
</li>


			</xsl:for-each>
		</ul>
	</xsl:template>
</xsl:stylesheet>
